// #include <qapp.h>
// #include <qdialog.h>
// #include <qlabel.h>
#include <stdio.h>
#include <kapp.h>
#include "dlgeditpal.h"
#include "dlgeditpal.moc"
#define TRS klocale->translate

PalEditDlg::PalEditDlg(unsigned long* CPtr, int NumCol, QWidget* parent=0, const char* name=0):
     QDialog (parent, name, WStyle_DialogBorder)
{
int Lauf;

   setFixedSize(400,450);
   TimerActive = FALSE;
   ColPtr=CPtr;
   NumColors = NumCol;
   VerlaufStart = -1;

   if (NumColors==2)
      ColCells = new KColorCells(this, 2, 1);
   else
      ColCells = new KColorCells(this, 16, 16);
   ColCells->setGeometry(10,10,380,380);
   for (Lauf=0; Lauf<NumColors; Lauf++)
      ColCells->setColor(Lauf, *(CPtr++));
   connect(ColCells, SIGNAL(colorSelected(int)), this, SLOT(ColSel()) );
   
   VerlaufBtn = new QPushButton(TRS("Verlauf"), this, "VerlaufBtn");
   VerlaufBtn->setGeometry(10,390,60,20);
   VerlaufBtn->setToggleButton(TRUE);
   connect(VerlaufBtn, SIGNAL(clicked()), this, SLOT(VerlaufToggle()) );

   QPushButton* MinusBtn = new QPushButton("-", this, "MinusBtn");
   MinusBtn->setGeometry(10,415,25,20);
   MinusBtn->setAutoRepeat(TRUE);
   connect(MinusBtn, SIGNAL(clicked()), this, SLOT(ScrollDown()) );

   QPushButton* PlusBtn = new QPushButton("+", this, "PlusBtn");
   PlusBtn->setGeometry(45,415,25,20);
   PlusBtn->setAutoRepeat(TRUE);
   connect(PlusBtn, SIGNAL(clicked()), this, SLOT(ScrollUp()) );

   QPushButton* OkBtn = new QPushButton(TRS("OK"), this, "OkBtn");
   OkBtn->setGeometry(110,410,80,30);
   connect(OkBtn, SIGNAL(clicked()), this, SLOT(accept()) );

   QPushButton* DefaultsBtn = new QPushButton(TRS("Defaults"), this, "DefaultsBtn");
   DefaultsBtn->setGeometry(210,410,80,30);
   connect(DefaultsBtn, SIGNAL(clicked()), this, SLOT(DefaultPal()) );

   QPushButton* CancelBtn = new QPushButton(TRS("Cancel"), this, "CancelBtn");
   CancelBtn->setGeometry(310,410,80,30);
   connect(CancelBtn, SIGNAL(clicked()), this, SLOT(reject()) );
}


void PalEditDlg::ColSel()
// Ausklick in das ColorGrid
{
int Sel;

   Sel = ColCells->getSelected();

   if (VerlaufBtn->isOn()) {   //Farbverlauf ist aktiviert
      Verlauf(VerlaufStart, Sel);
      VerlaufBtn->setOn(FALSE);
   } else
   if (TimerActive) {
      fprintf(stdout,"doppelklick\n");
      TimerActive = FALSE;
      KColorDialog ColDlg(this,"Farbe whlen",TRUE);
      ColDlg.setColor(ColCells->color(Sel));
      if (ColDlg.exec()) {
         fprintf(stdout,"ColDlg ok\n");
         ColCells->setColor(Sel, ColDlg.color());
      }
   } else {
      QTimer::singleShot( 500, this, SLOT(TimerEnd()) );
      TimerActive=TRUE;
      fprintf(stdout,"einfachklick\n");
   }
   fprintf(stdout,"colsel %d\n", Sel);
}

void PalEditDlg::TimerEnd()
{
   TimerActive=FALSE;
//   fprintf(stdout,"timerend\n");
}

void PalEditDlg::VerlaufToggle()
{
   fprintf(stdout,"Verlauftoggle\n");
   if (VerlaufBtn->isOn()) {
      VerlaufStart = ColCells->getSelected();  // Startwert merken
      fprintf(stdout,"ein\n");
   } else
      VerlaufStart = -1;         // kein Verlauf;
}

void PalEditDlg::Verlauf(int Anfang, int End) {
int Lauf;
int diff;
int sr,sg,sb,er,eg,eb;  // Farbwerte am Anfang und Ende
int r,g,b;
int Start,Ende;
QColor Col;

//   fprintf(stdout,"Verlauf von %d nach %d\n", Anfang, End);
   if (End>Anfang) {
      Start = Anfang;
      Ende = End;
   } else {
      Start = End;
      Ende = Anfang;
   }

   diff = (Ende-Start);   // Anzahl der zu ndernden Werte
   if (diff <= 0) return;   // End < Anf
   // Farbanteile am Start
   Col = ColCells->color(Start);

   sr = Col.red();
   sg = Col.green();
   sb = Col.blue();
   // Farbanteile am Ende
   Col = ColCells->color(Ende);
   er = Col.red();
   eg = Col.green();
   eb = Col.blue();
   // Farben interpolieren
   for (Lauf=Start+1; Lauf<Ende; Lauf++) {
      r = sr + (er-sr)*(Lauf-Start)/diff;
      g = sg + (eg-sg)*(Lauf-Start)/diff;
      b = sb + (eb-sb)*(Lauf-Start)/diff;
      ColCells->setColor(Lauf, qRgb(r,g,b));
   }
}

unsigned long PalEditDlg::GetColor(int No)
{
QColor C;
   C = ColCells->color(No);
   return qRgb(C.red(), C.green(), C.blue());
}

void PalEditDlg::DefaultPal()
{
   if (NumColors==2) {
      ColCells->setColor(0, qRgb(0,0,0));//   = 0x00000000;     // schwarz
      ColCells->setColor(1, qRgb(255,255,255));//   = 0x00FFFFFF;     // wei
   } else {
      ColCells->setColor(0, qRgb(0,0,0));//   = 0x00000000;     // schwarz
      ColCells->setColor(31, qRgb(0,0,255)); //  = 0x000000FF;     // blau
      Verlauf(0,31);
      ColCells->setColor(63, qRgb(200,0,200)); //  = 0x00800080;     // rot-blau (dunkel)
      Verlauf(31,63);
      ColCells->setColor(95, qRgb(255,0,0));//  = 0x00FF0000;     // rot
      Verlauf(63, 95);
      ColCells->setColor(127, qRgb(200,200,0));// = 0x00808000;     // rot-grn (dunkel)
      Verlauf(95,127);
      ColCells->setColor(159, qRgb(0,255,0));// = 0x0000FF00;     // grn
      Verlauf(127,159);
      ColCells->setColor(191, qRgb(0,200,200));// = 0x00008080;     // blau-grn (dunkel)
      Verlauf(159,191);
      ColCells->setColor(223, qRgb(200,200,200));// = 0x00808080;     // grau
      Verlauf(191, 223);
      ColCells->setColor(255, qRgb(0,0,0));// = 0x00000000;     // schwarz
      Verlauf(223,255);
   }
}

void PalEditDlg::ScrollDown()
{
QColor Help;
int Lauf;

   Help = ColCells->color(0);
   for (Lauf=0; Lauf<NumColors-1; Lauf++)
      ColCells->setColor(Lauf, ColCells->color(Lauf+1));
   ColCells->setColor(NumColors-1, Help);
}

void PalEditDlg::ScrollUp()
{
QColor Help;
int Lauf;

   Help = ColCells->color(NumColors-1);
   for (Lauf=NumColors-1; Lauf>0; Lauf--)
      ColCells->setColor(Lauf, ColCells->color(Lauf-1));
   ColCells->setColor(0, Help);
}
