#ifndef PALEDIT_H
#define PALEDIT_H

#include <qdialog.h>
#include <qwidget.h>
#include <qlabel.h>
#include <qpushbt.h>
#include <qpixmap.h>
#include <kcolordlg.h>
#include <qtimer.h>
#include <qcolor.h>

class PalEditDlg : public QDialog
{
Q_OBJECT
public:
   PalEditDlg(unsigned long* CPtr, int NumCol, QWidget* parent=0, const char* name=0);
   unsigned long GetColor(int No);   
signals:
   
private slots:
   void ColSel();
   void TimerEnd();
   void VerlaufToggle();
   void DefaultPal();
   void ScrollDown();   // Palette nach links rotieren
   void ScrollUp();     // Palette nach rechts rotieren

private:
   int TimerActive;
   KColorCells* ColCells;
   QPushButton* VerlaufBtn, *PlusBtn, *MinusBtn;
   unsigned long* ColPtr;
   int VerlaufStart;        // Startpunkt eines Farbverlaufes
   int NumColors;           // Anzahl der Farben
   
   void Verlauf(int Anfang, int End);   // Farbverlauf erzeugen
};

#endif