#include <stdio.h>
#include <iostream.h>
#include "dlgfilesettings.h"
#include "dlgfilesettings.moc"
#define TRS klocale->translate

FileSettingsDlg::FileSettingsDlg(DrawWidget* iClient, QWidget* parent=0, const char* name=0):
     QDialog (parent, name, WStyle_DialogBorder)
{
QString StartFile;
   Client = iClient;
   setFixedSize(400,300);
   setCaption(TRS("Filesettings"));
   
   QWidget* General = new QWidget(this, "General");
   // Filemask
   QLabel * MaskLab = new QLabel(TRS("Filemask:"), General, "FileLab");
   MaskLab->setGeometry(20,20,80,20);
   FileMaskEdit = new QLineEdit(General, "FileMaskEdit");
   FileMaskEdit->setGeometry(110,20,100,25);
   FileMaskEdit->setText(Client->Fractal->FileMask);
   
   // FileCounter
   QLabel * CountLab = new QLabel(TRS("Filecounter:"), General, "CountLab");
   CountLab->setGeometry(20,50,80,20);
   FileCountSpin = new KNumericSpinBox(General, "FileCountSpin");
   FileCountSpin->setGeometry(110,50,50,25);
   FileCountSpin->setRange(0,100000000);
   FileCountSpin->setEditable(TRUE);
   FileCountSpin->setValue(Client->Fractal->FileCount);



   QWidget* StartUp = new QWidget(this, "StartUp");
   
   ColorMapCheck = new QCheckBox(TRS("Save Colormap in Parameterfile"), StartUp, "ColorMapCheck");
   ColorMapCheck->setGeometry(20,20,300,20);
   ColorMapCheck->setChecked(Client->SaveColorMapBool);
   
   QLabel* Label1 = new QLabel(TRS("Startupfile :"), StartUp, "Label1");
   Label1->setGeometry(20,50,75,18);
   StartUpFileEdit = new QLineEdit(StartUp, "StartUpFileEdit");
   StartUpFileEdit->setGeometry(110,50,200,22);

   Config = KApplication::getKApplication()->getConfig();
   Config->setGroup("Allgemeines");
   StartFile = Config->readEntry("StartParameter","");
   StartUpFileEdit->setText(StartFile);

   QPushButton* SuchBtn = new QPushButton(TRS("Look"), StartUp, "SuchBtn");
   SuchBtn->setGeometry(320,50,55,22);
   connect(SuchBtn, SIGNAL(clicked()), this, SLOT(SuchBtnClick()) );

   // FractalDir
   QLabel* FracLab = new QLabel(TRS("Fractaldir:"), StartUp, "FracLab");
   FracLab->setGeometry(20,80,75,18);
   FractalDirEdit = new QLineEdit(StartUp, "FractalDirEdit");
   FractalDirEdit->setGeometry(110,80,200,25);
   FractalDirEdit->setText(MandelDir.absPath());
   // Suchbutton
   QPushButton* MandDirBtn = new QPushButton(TRS("Look"), StartUp, "MandDirBtn");
   MandDirBtn->setGeometry(320,80,55,22);
   connect(MandDirBtn, SIGNAL(clicked()), this, SLOT(MandDirBtnClick()) );
   
   // ColorMapDir
   QLabel* ColorLab = new QLabel(TRS("Colormapdir:"), StartUp, "ColorLab");
   ColorLab->setGeometry(20,110,75,18);
   ColorMapDirEdit = new QLineEdit(StartUp, "ColorMapDirEdit");
   ColorMapDirEdit->setGeometry(110,110,200,25);
   ColorMapDirEdit->setText(ColorMapDir.absPath());
   // Suchbutton
   QPushButton* ColorMapDirBtn = new QPushButton(TRS("Look"), StartUp, "ColorMapDirBtn");
   ColorMapDirBtn->setGeometry(320,110,55,22);
   connect(ColorMapDirBtn, SIGNAL(clicked()), this, SLOT(ColorMapDirBtnClick()) );
   

   Pages = new KTabCtl(this,"Pages");
   Pages->setGeometry(0,0,390,250);
   Pages->addTab(General, TRS("General"));
   Pages->addTab(StartUp, TRS("Startup"));

   QPushButton* OkBtn = new QPushButton(TRS("OK"), this, "OkBtn");
   OkBtn->setGeometry(210,260,80,30);
   connect(OkBtn, SIGNAL(clicked()), this, SLOT(OkBtnClick()) );

   QPushButton* CancelBtn = new QPushButton(TRS("Cancel"), this, "CancelBtn");
   CancelBtn->setGeometry(310,260,80,30);
   connect(CancelBtn, SIGNAL(clicked()), this, SLOT(reject()) );
}

int FileSettingsDlg::SetValues()
{
   Client->SaveColorMapBool = ColorMapCheck->isChecked();
   sprintf(Client->Fractal->FileMask, "%s", FileMaskEdit->text());
   Client->Fractal->FileCount = FileCountSpin->getValue();
   
   Config->writeEntry("StartParameter", StartUpFileEdit->text());
   Config->sync();

   return TRUE;
}

void FileSettingsDlg::OkBtnClick()
{
QDir Strg;

   Strg = FractalDirEdit->text();
//   cout << Strg.absPath();
   if (strlen(FractalDirEdit->text())>0) {
      if (!Strg.exists()) {
         QMessageBox::message(Strg.path(), "Mandel-Verzeichnis existiert nicht");
         return;
      }
      MandelDir.setPath(Strg.absPath());
      //cout << MandelDir.absPath();
   }
   Strg = ColorMapDirEdit->text();
   if (strlen(ColorMapDirEdit->text())>0) {
      if (!Strg.exists()) {
         QMessageBox::message(Strg.path(), "Colormap-Verzeichnis existiert nicht");
         return;
      }
      ColorMapDir.setPath(Strg.absPath());
   }
   Config->setGroup("Allgemeines");
   Config->writeEntry("MandelDir",   MandelDir.absPath());
   Config->writeEntry("ColorMapDir", ColorMapDir.absPath());
   Config->sync();

   accept();
}

void FileSettingsDlg::SuchBtnClick()
{
   QString f = KFileDialog::getOpenFileName( 0, "*.par", this );
   if ( !f.isEmpty() )
      StartUpFileEdit->setText(f);
}

void FileSettingsDlg::MandDirBtnClick()
{
   QString f = KDirDialog::getDirectory(MandelDir.absPath(), this, "MandDirSel");
   if ( !f.isEmpty() )
      FractalDirEdit->setText(f);
}

void FileSettingsDlg::ColorMapDirBtnClick()
{
   QString f = KDirDialog::getDirectory(ColorMapDir.absPath(), this, "ColDirSel");
   if ( !f.isEmpty() )
      ColorMapDirEdit->setText(f);
}
