#ifndef DLGFRACPARAMS_H
#define DLGFRACPARAMS_H

#include <qtabdlg.h>
#include <qlined.h>
#include <qlabel.h>
#include <qlist.h>
#include <kspinbox.h>
#include <qchkbox.h>
#include <qcombo.h>
#include <qwindow.h>
#include <ktopwidget.h>
#include <qgrpbox.h>

#include "fracglobals.h"
#include "basefrac.h"
#include "kmandel.h"

class FracParamsDlg : public QTabDialog
{
Q_OBJECT
public:
   FracParamsDlg(DrawWidget* Clnt, QWidget* parent=0, const char* name=0);
   char* SetParams(void);   // Parameter schreiben
   
   // Daten auf der Steite "Corners" lesen/schreiben
   //void SetCornerParams(double x1, double y1, double x2, double y2);
   //int GetCornerParams(double *x1, double *y1, double *x2, double *y2);
   // Parameter auf der Seite "General" lesen/schreiben
   //void SetGeneralParams(int MaxIter);
   //int GetGeneralParams(int* MaxIter);
   // Parameter auf der Seite "Convergency" lesen/schreiben
   //void SetConvParams(int ConvMode, double BailOut);
   //int GetConvParams(int* ConvMode, double* BailOut);
   // Parameter auf der Seite "Params" lesen/schreiben
   //void SetParamParams(double *p);
   //int GetParamParams(double *p);
   // Information auf Seite Info, nur lesen
   //void SetInfoParams(int Nr, char* Name, char* InfoText);
   //void DefaultCorners();   // Eckpunkte auf Defaultwerte setzen
signals:

private slots:
   void DefaultCorners();
   void DefaultParameters();
   void PPBtnClick();
   void MMBtnClick();
   
private:
   QLineEdit *MinXEdit, *MaxXEdit, *MinYEdit, *MaxYEdit, *BailEdit,
             *LogShiftEdit;
   KNumericSpinBox  *MaxIterSpin, *LogFirstColorSpin;
   KListSpinBox *ConvSpin;
   QLineEdit *Par[16];   // Parameter p0..p15
   QLabel *FracNr, *FracName, *FracInfo;
   BaseFract* Fractal;
   DrawWidget* Client;
   QComboBox* InsideCombo, *OutsideCombo, *CalcCombo, *ColorCombo;
   KNumericSpinBox *InsideColorSpin, *OutsideColorSpin;
   QLineEdit* PotentialEdit;
   QCheckBox *AutoLogCheck;
   
   // Kopien der Parameter, falls "Cancel" gedrckt wurde
   //double li,re,un,ob;   // Eckpunkte
   //double p[16];         // Float-Params
   //long l[16];           // long-Parameter
   //double BailOut;       
   //int ConvTest;
};

#endif