#include <stdio.h>
#include "dlgparamanimedit.h"
#include "dlgparanim.h"
#include "dlgparanim.moc"

#define TRS klocale->translate
#define WIDTH 575
#define HEIGHT 280
long SplColors[16] = 
{0x000000, 0x800000, 0x008000, 0x808000, 0x000080, 0x800080, 0x008080, 0x606060,
 0xB0B0B0, 0xFF0000, 0x00FF00, 0xFFFF00, 0x0000FF, 0xFF00FF, 0x00FFFF, 0xFFFFFF};
int dummy=0;

MyFrame::MyFrame ( QWidget * parent=0, const char * name=0, WFlags f=0, bool allowLines=TRUE ):
   QFrame(parent, name, f, allowLines)
{
   XPos = -1;
   AnimDlg = (ParameterAnimDlg*)parent;
}

//void MyFrame::paintEvent ( QPaintEvent * ) {
//printf("MyFrame::paintEvent\n");
//}

void MyFrame::mousePressEvent ( QMouseEvent * mev) {
printf("MyFrame::mousePressEvent %d\n", mev->x());

   XPos = mev->x();
   //update();
   //AnimDlg->update();
   emit NeuZeichnen();
}
                      
ParameterAnimDlg::ParameterAnimDlg(DrawWidget* Clnt, QWidget* parent=0, const char* name=0):
     QDialog (parent, name, WStyle_DialogBorder)
{
int Lauf;
//fprintf(stdout,"ParameterAnimDlg::ParameterAnimDlg\n");

   setCaption(TRS("Parameteranim"));
   setFixedSize(600,450);
   Client = Clnt;

   CurrentSpl=0;
   o=1.0;
   u=0.0;
   l=0.0;
   r=1.0;   
   DispBits = 3;
   for (Lauf=0; Lauf<16; Lauf++)
      Spl[Lauf].defaultInit();
   Running = FALSE;

   QWidget* ParameterPage = new QWidget(this, "ParameterPage");
   SplFrame = new MyFrame(ParameterPage);
   SplFrame->setGeometry(5,5,575,280);
   SplFrame->setFrameStyle(QFrame::Panel|QFrame::Sunken);
   SplFrame->setLineWidth(2);
   Paint = new QPainter();
   
   ParNameLab = new QLabel("", ParameterPage, "ParNameLab");
   ParNameLab->setGeometry(10,295,100,20);
   
   ColorRect = new QWidget(ParameterPage, "ColorRect");
   ColorRect->setGeometry(115,300,30,10);
   ColorRect->setBackgroundColor(QRgb(0xFF0000));
   
   QPushButton* PrevBtn = new QPushButton("<--", ParameterPage, "PrevBtn");
   PrevBtn->setGeometry(200,295,50,30);
   connect(PrevBtn, SIGNAL(clicked()), SLOT(PrevBtnClick()) );
   QPushButton* NextBtn = new QPushButton("-->", ParameterPage, "NextBtn");
   NextBtn->setGeometry(200,325,50,30);
   connect(NextBtn, SIGNAL(clicked()), SLOT(NextBtnClick()) );
   QPushButton* EditBtn = new QPushButton(TRS("Edit"), ParameterPage, "EditBtn");
   EditBtn->setGeometry(10,325,70,30);
   connect(EditBtn, SIGNAL(clicked()), SLOT(EditBtnClick()) );
   QPushButton* CalcBtn = new QPushButton(TRS("Testcalc"), ParameterPage, "CalcBtn");
   CalcBtn->setGeometry(270,325,70,30);
   connect(CalcBtn, SIGNAL(clicked()), SLOT(CalcBtnClick()) );
   DisplayCheck = new QCheckBox(TRS("Display"), ParameterPage, "DisplayCheck");
   DisplayCheck->setGeometry(100,320,100,20);
   DisplayCheck->setChecked(DispBits & (1<<CurrentSpl));
   connect(DisplayCheck, SIGNAL(clicked()), SLOT(DisplayCheckClick()) );

   ZoomLab = new QLabel("Zoom:", ParameterPage, "ZoomLab");
   ZoomLab->setGeometry(270,300,100,20);
   
   PosNegCheck = new QCheckBox(TRS("pos/neg."), ParameterPage, "PosNegCheck");
   PosNegCheck->setGeometry(380,300,100,20);
   PosNegCheck->setChecked(FALSE);
   connect(PosNegCheck, SIGNAL(clicked()), SLOT(PosNegCheckClick()));

   ZoomInBtn = new QPushButton(ParameterPage, "ZoomInBtn");
   ZoomInBtn->setGeometry(380,330,25,25);
   ZoomInBtn->setPixmap(kapp->getIconLoader()->loadIcon("viewmag+.xpm"));
   connect(ZoomInBtn, SIGNAL(clicked()), SLOT(ZoomInBtnClick()));
   
   ZoomOutBtn = new QPushButton(ParameterPage, "ZoomOutBtn");
   ZoomOutBtn->setGeometry(410,330,25,25);
   ZoomOutBtn->setPixmap(kapp->getIconLoader()->loadIcon("viewmag-.xpm"));
   connect(ZoomOutBtn, SIGNAL(clicked()), SLOT(ZoomOutBtnClick()));
   
   QWidget* PicturePage   = new QWidget(this, "PicturePage");

   QLabel *NumPicLab = new QLabel(TRS("# Pictures"), PicturePage);
   NumPicLab->setGeometry(10,20,100,20);
   NumPicSpin = new KNumericSpinBox(PicturePage, "NumPicSpin");
   NumPicSpin->setGeometry(120,20,80,25);
   NumPicSpin->setRange(0,100000);
   NumPicSpin->setEditable(TRUE);
   NumPicSpin->setValue(100);
   
   QLabel *FirstImgLab = new QLabel(TRS("Start Image"), PicturePage);
   FirstImgLab->setGeometry(10,60,100,20);
   FirstImgSpin = new KNumericSpinBox(PicturePage, "FirstImgSpin");
   FirstImgSpin->setGeometry(120,60,80,25);
   FirstImgSpin->setRange(0,100000);
   FirstImgSpin->setEditable(TRUE);
   FirstImgSpin->setValue(0);
   
   QLabel *LastImgLab = new QLabel(TRS("Last Image"), PicturePage);
   LastImgLab->setGeometry(10,90,100,20);
   LastImgSpin = new KNumericSpinBox(PicturePage, "LastImgSpin");
   LastImgSpin->setGeometry(120,90,80,25);
   LastImgSpin->setRange(0,100000);
   LastImgSpin->setEditable(TRUE);
   LastImgSpin->setValue(100);
   
   QLabel *IncrementLab = new QLabel(TRS("Increment"), PicturePage);
   IncrementLab->setGeometry(10,120,100,20);
   IncrementSpin = new KNumericSpinBox(PicturePage, "IncrementSpin");
   IncrementSpin->setGeometry(120,120,80,25);
   IncrementSpin->setRange(0,100000);
   IncrementSpin->setEditable(TRUE);
   IncrementSpin->setValue(1);
   
   QLabel *LineLab = new QLabel(TRS("File Mask"), PicturePage);
   LineLab->setGeometry(10,160,100,20);
   MaskEdit = new QLineEdit(PicturePage, "MaskEdit");
   MaskEdit->setGeometry(120,160,120,25);
   MaskEdit->setText(Client->Fractal->FileMask);
   
   QWidget* StatusPage   = new QWidget(this, "StatusPage");
   ProgressBar = new KProgress(0, NumPicSpin->getValue(), 0, KProgress::Horizontal, StatusPage, "ProgressBar");
   ProgressBar->setGeometry(30,100,300,25);
   
   QLabel * AktionLab = new QLabel(TRS("Action:"), StatusPage, "AktionLab");
   AktionLab->setGeometry(30,50,60,20);
   StatusLab = new QLabel(TRS("nothing"), StatusPage, "StatusLab");
   StatusLab->setGeometry(100,50,200,20);
   
   connect(Client, SIGNAL(FertigSig()), this, SLOT(Fertig()));

   Pages = new KTabCtl(this, "Pages");
   Pages->setGeometry(0,0,590,400);
   Pages->addTab(ParameterPage, TRS("Parameters"));
   Pages->addTab(PicturePage, TRS("Pictures"));
   Pages->addTab(StatusPage, TRS("Status"));
   connect(Pages, SIGNAL(tabSelected(int)), this, SLOT(TestSchlot(int)));
   connect(SplFrame, SIGNAL(NeuZeichnen()), SLOT(SplFrameUpdate()));

   // Load-Button
   QPushButton *LoadBtn = new QPushButton(TRS("Load"), this, "LoadBtn");
   LoadBtn->setGeometry(20,410,80,30);
   connect(LoadBtn, SIGNAL(clicked()), SLOT(LoadBtnClick()) );

   // Save-Button
   QPushButton *SaveBtn = new QPushButton(TRS("Save"), this, "SaveBtn");
   SaveBtn->setGeometry(120,410,80,30);
   connect(SaveBtn, SIGNAL(clicked()), SLOT(SaveBtnClick()) );

   // Start- und Abort-Button liegen bereinader, es ist aber nur einer
   // sichtbar
   // Start-Button
   StartBtn = new QPushButton(TRS("Start"), this, "StartBtn");
   StartBtn->setGeometry(400,410,80,30);
   connect(StartBtn, SIGNAL(clicked()), SLOT(StartBtnClick()) );

   // Abort-Button
   AbortBtn = new QPushButton(TRS("Abort"), this, "AbortBtn");
   AbortBtn->setGeometry(400,410,80,30);
   AbortBtn->hide();
   connect(AbortBtn, SIGNAL(clicked()), SLOT(AbortBtnClick()) );

   // Close-Button
   QPushButton *CloseBtn = new QPushButton(TRS("Close"), this, "CloseBtn");
   CloseBtn->setGeometry(500,410,80,30);
   connect(CloseBtn, SIGNAL(clicked()), SLOT(CloseBtnClick()) );
   
   ShowStatistic();
}


void ParameterAnimDlg::ReCalc() {
   Client->AbortCalc();
   Client->update();
}

void ParameterAnimDlg::Fertig() {
QString Name,Help;
   printf("PA-Ferig\n");
   if (!Running) return;
   // speichern
   Name.sprintf(MaskEdit->text(), PicNr);
   // Help = TRS("Saving ")+Name;
   Help = MandelDir.absPath() + "/" + Name+".bmp";
   StatusLab->setText("Speichere "+Help);
   Client->SaveImage(Help.data());
   
   PicNr+=IncrementSpin->getValue();
   if (PicNr > LastImgSpin->getValue()) {
      Running = FALSE;
      Pages->setTabEnabled("ParameterPage",TRUE);
      Pages->setTabEnabled("PicturePage",TRUE);
      StatusLab->setText(TRS("nothing"));
      AbortBtn->hide();
      StartBtn->show();
      return;
   }
   ProgressBar->setValue(PicNr*100/NumPicSpin->getValue());
   BerechneBild(PicNr);
   Name.sprintf(MaskEdit->text(), PicNr);
   Help = TRS("Calculating ")+Name;
   StatusLab->setText(Help);
   BerechneBild(PicNr);
}

void ParameterAnimDlg::paintEvent(QPaintEvent*) {
printf("paint\n");
   Plot();
}

void ParameterAnimDlg::Plot(void) {
int nx,ny;   // Nulllinien
double dx,dy; // Schrittweiten
int y,ay;  // aktuelle Werte, letzte Werte
int Lauf,Nr;
int wd,ht,fw;   // Breite, Hhe

   Paint->begin(SplFrame);
   fw = SplFrame->lineWidth();
   wd = SplFrame->width()-2*fw;
   ht = SplFrame->height()-2*fw-1;
   SplFrame->erase(fw,fw, wd ,ht);
   Paint->setPen(QRgb(0x00000000));
   dy=(o-u)/ht;
   ny=(int)(-u/dy)-fw;
   dx=(r-l)/wd;
   nx=(int)(-l/dx)+fw;
   Paint->drawLine(0,ht-ny,wd,ht-ny); //Waag
   Paint->drawLine(nx,0,nx,ht);            // senkrecht
   Paint->drawLine(nx-2,ht-(int)(ny+1/dy),nx+2,ht-(int)(ny+1/dy));    //1 senk
   Paint->drawLine((int)(nx+1/dx),ht-ny,(int)(nx+1/dx),ht-ny);    //1 senk

   if (SplFrame->XPos >= 0) {
      Paint->setPen(DotLine);
      Paint->drawLine(SplFrame->XPos,fw,SplFrame->XPos,SplFrame->height()-fw);
      Paint->setPen(SolidLine);
   }
/*   Nr = 0;
   // Spline - Ausgabe der Knotenpunkte
   Paint->setPen(QRgb(0x000000FF));
   for (Lauf=0; Lauf<Spl[Nr].numPoints();Lauf++) {
     x = (int)(nx+Spl[Nr].getX(Lauf)/dx);
     y = (int)(ht-ny-Spl[Nr].getY(Lauf)/dy);
     Paint->drawLine(x-2,y,x+2,y);
     Paint->drawLine(x,y-2,x,y+2);
   }
  */ 
   // Spline - Ausgabe der Funktion
   printf("DispBits %d\n" , DispBits);
   for (Nr=0; Nr<16; Nr++) {
      if (DispBits & (1<<Nr)) {
         Paint->setPen(QRgb(SplColors[Nr]));
         ay = (int)(fw+ny+Spl[Nr].spline(l)/dy);
         for (Lauf=1; Lauf<wd; Lauf++) {
            y = (int)(ny+Spl[Nr].spline(l+Lauf*dx)/dy);
            Paint->drawLine(fw+Lauf-1,ht-ay,fw+Lauf,ht-y);
            ay=y;
         }
      }
   }

   Paint->end();
}

void ParameterAnimDlg::PrevBtnClick() {
printf("prev\n");
   if (CurrentSpl>0) CurrentSpl--; else CurrentSpl=15;
   ShowStatistic();
}

void ParameterAnimDlg::NextBtnClick() {
printf("next\n");
   if (CurrentSpl<15) CurrentSpl++; else CurrentSpl=0;
   ShowStatistic();
}

void ParameterAnimDlg::EditBtnClick() {
ParamAnimEditDlg PAEDlg(this, "PAEDlg");
//printf("edit\n");

   PAEDlg.SplEdit->setZoom(1.0/o);
   PAEDlg.SplEdit->setPosNeg(PosNegCheck->isChecked());
   if (!PAEDlg.exec())
      PAEDlg.SplEdit->cancel();
   SplFrame->update();
}

void ParameterAnimDlg::DisplayCheckClick() {
printf("displaychekcclick %d %X %X\n",CurrentSpl,(1<<CurrentSpl),  ~(1<<CurrentSpl));
   if (DisplayCheck->isChecked())
      DispBits |= (1<<CurrentSpl);
   else
      DispBits &= ~(1<<CurrentSpl);
   ShowStatistic();
   update();
//   qApp->processEvents();
}

void ParameterAnimDlg::ShowStatistic(void) {
char Strg[32];
printf("shotstatistic\n");

   sprintf(Strg,"Parameter: %d", CurrentSpl);
   ParNameLab->setText(Strg);
   ColorRect->setBackgroundColor(QRgb(SplColors[CurrentSpl]));
   DisplayCheck->setChecked(DispBits & (1<<CurrentSpl));
   
   sprintf(Strg,"Zoom:%0.4f", 1.0/o);
   ZoomLab->setText(Strg);
}

void ParameterAnimDlg::LoadBtnClick(void) {
int Loof,i,res;
ParameterFile *f;
QString DateiName;
struct AnimFrameType Header;
struct AnimSplineType SplData;

   DateiName = KFileDialog::getOpenFileName(MandelDir.absPath(), "*.anm", this );
   if (DateiName.isEmpty()) return;   // Cancel im Dialoch

   if (DateiName.right(4) != ".anm") {
      DateiName += ".anm";
      //fprintf(stdout,"keine Endung '.anm'\n");
      //fprintf(stdout,"Endung jetzt >%s<\n",DateiName.data());
   }
   
   printf("Datei:%s\n",DateiName.data());
   f = new ParameterFile(DateiName.data());
   res = f->Open(PAR_READ);
   if (res != PAR_OK) {
      QMessageBox::warning(this, TRS("File Not Found"),
                           DateiName, 1,0);
      return;
   }
   Header.Zoom = 1.0;
   Header.PosNeg = FALSE;
   Header.DispBits = 3;
   res = f->BlockSize('A','M');
   if (res < 0) {
      QMessageBox::warning(this, TRS("File Open Error"),
                           TRS("Possible not a MU animfile"), 1,0);
      return;
   }
   res = f->ReadBlock('A','M', &Header, res /*sizeof(Header)*/);
   if (res != PAR_OK) {
      QMessageBox::warning(this, TRS("File Open Error"),
                           TRS("Possible not a MU animfile"), 1,0);
      return;
   }
   
   NumPicSpin->setValue(Header.NumPics);
   FirstImgSpin->setValue(Header.StartPic);
   LastImgSpin->setValue(Header.EndPic);
   IncrementSpin->setValue(Header.Increment);
   MaskEdit->setText(Header.Mask);
   PosNegCheck->setChecked(Header.PosNeg);
   o = Header.Zoom;
   if (Header.PosNeg) {
      u=-Header.Zoom;
      o=Header.Zoom; 
   } else u=0.0;
   DispBits = Header.DispBits;
   
   for (Loof=0; Loof<16; Loof++) {
      Spl[Loof].clear();
      res = f->BlockSize('S','A'+Loof);
      if (res < 0) {
         QMessageBox::warning(this, TRS("File Open Error"),
                              TRS("File is corrupted"), 1,0);
         Spl[Loof].defaultInit();
         return;
      }
      f->ReadBlock('S','A'+Loof, &SplData, res);
      //printf("Count=%d\n",SplData.Count);
      for (i=0; i<SplData.Count; i++) {
         Spl[Loof].add(SplData.Points[i].X, SplData.Points[i].Y);
         //printf("%7.2f   %7.2f\n",Spl[Loof].getX(i),Spl[Loof].getY(i));
      }
      Spl[Loof].setNatural(SplData.Natuerlich);
      Spl[Loof].setY1(SplData.y1);
      Spl[Loof].setYn(SplData.yn);
   }
   
   f->Close();delete f;
   ShowStatistic();
printf("%7.2f   %7.2f  %7.2f\n",o,u,Header.Zoom);
}

void ParameterAnimDlg::SaveBtnClick(void) {
int Loof,i,lng;
ParameterFile *f;
QString DateiName;
struct AnimFrameType Header;
struct AnimSplineType SplData;

   DateiName = KFileDialog::getSaveFileName(MandelDir.absPath(), "*.anm", this );
   if (DateiName.isEmpty()) return;   // Cancel im Dialoch

   if (DateiName.right(4) != ".anm") {
      DateiName += ".anm";
      //fprintf(stdout,"keine Endung '.anm'\n");
      //fprintf(stdout,"Endung jetzt >%s<\n",DateiName.data());
   }
   if (QFile::exists(DateiName.data())){ // Datei existiert bereits
      if (!QMessageBox::query(TRS("Confirm"),TRS("Overwrite the existing file?")))
         return;
   }
   
   printf("Datei:%s\n",DateiName.data());
   f = new ParameterFile(DateiName.data());
   f->Open(PAR_WRITE);
   
   // Header schreiben
   Header.NumPics   = NumPicSpin->getValue();
   Header.StartPic  = FirstImgSpin->getValue();
   Header.EndPic    = LastImgSpin->getValue();
   Header.Increment = IncrementSpin->getValue();
   Header.PosNeg    = PosNegCheck->isChecked();
   Header.Zoom      = o;
   Header.DispBits  = DispBits;
   strcpy(Header.Mask, MaskEdit->text());
   f->WriteBlock('A','M', &Header, sizeof(Header));

   // Splines schreiben
   lng = sizeof(SplData.Natuerlich)+
         sizeof(SplData.y1)+sizeof(SplData.yn)+sizeof(SplData.Count);
   for (Loof=0; Loof<16; Loof++) {
      SplData.Natuerlich = Spl[Loof].natural();
      SplData.y1 = Spl[Loof].getY1();
      SplData.yn = Spl[Loof].getYn();
      SplData.Count = Spl[Loof].numPoints();
      //printf("Count=%d\n",SplData.Count);
      for (i=0; i<SplData.Count; i++) {
         SplData.Points[i].X = Spl[Loof].getX(i);
         SplData.Points[i].Y = Spl[Loof].getY(i);
         //printf("%7.2f   %7.2f\n",Spl[Loof].getX(i),Spl[Loof].getY(i));
      }
      f->WriteBlock('S','A'+Loof, &SplData, lng+2*sizeof(double)*SplData.Count);
   }
   
   f->Close();
   
   delete f;
printf("%7.2f   %7.2f   %7.2f\n",o,u,Header.Zoom);
}

void ParameterAnimDlg::TestSchlot(int i) {
printf("Test %d\n",i);

   if (i==0) { /*ShowStatistic();*/ update(); }
}

void ParameterAnimDlg::StartBtnClick() {
int Fehler=0;
char Errors[3][32] = {"Firstimage < 0","Firstimage > Lastimage", "Lastimage > Numimages"};
printf("Start\n");

   // Werte prfen
   if (FirstImgSpin->getValue()<0) Fehler = 1;
   if (LastImgSpin->getValue() < FirstImgSpin->getValue()) Fehler = 2;
   if (LastImgSpin->getValue() > NumPicSpin->getValue()) Fehler = 3;
   if (Fehler) {
      QMessageBox::warning(this, TRS("Input Error"),
                           TRS(Errors[Fehler-1]), 1,0);
      return;
   }
   
   StartBtn->hide();
   AbortBtn->show();
   Pages->setTabEnabled("ParameterPage",FALSE);
   Pages->setTabEnabled("PicturePage",FALSE);
   Running = TRUE;
   PicNr = FirstImgSpin->getValue();
   BerechneBild(PicNr);
}

void ParameterAnimDlg::AbortBtnClick() {
printf("Abort\n");

   StartBtn->show();
   AbortBtn->hide();
   Pages->setTabEnabled("ParameterPage",TRUE);
   Pages->setTabEnabled("PicturePage",TRUE);
   Running = FALSE;
}

void ParameterAnimDlg::SplFrameUpdate() {
   update();
}

void ParameterAnimDlg::CalcBtnClick() {
int i, lw;
printf("Calc\n");

   lw = SplFrame->lineWidth();  // Rahmenbreite
   i = NumPicSpin->getValue() * (SplFrame->XPos-lw) / (SplFrame->width()-2*lw);
   BerechneBild(i);
}

void ParameterAnimDlg::BerechneBild(int Nr) {
double x,y;
int Lauf;

   Client->AbortCalc();
   // Berechneung der Spline-X-Koordinate
   x = (1.0*Nr) / NumPicSpin->getValue();
   
   // Setzen der Parameter
   for (Lauf=0; Lauf<16; Lauf++) {
      y = Spl[Lauf].spline(x);
      Client->Fractal->p[Lauf] = y;
   }
   Client->update();
}

void ParameterAnimDlg::CloseBtnClick() {
   Running = FALSE;
   reject();
}

void ParameterAnimDlg::PosNegCheckClick() {
   if (PosNegCheck->isChecked()) {
      u = -o;
   } else {
      u = 0;
   }
   update();
}

void ParameterAnimDlg::ZoomInBtnClick() {
   o *= 0.5;
   u *= 0.5;
   update();
   ShowStatistic();
}

void ParameterAnimDlg::ZoomOutBtnClick() {
   o *= 2.0;
   u *= 2.0;
   update();
   ShowStatistic();
}

