#ifndef DLGPARANIM_H
#define DLGPARANIM_H

#include <qdialog.h>
#include <qwidget.h>
#include <qlabel.h>
#include <qpushbt.h>
#include <qlined.h>
#include <qframe.h>
#include <kspinbox.h>
#include <ktabctl.h>
#include <kfiledialog.h>
#include <kspline.h>
#include <kprogress.h>

#include "basefrac.h"
#include "kmandel.h"

class ParameterAnimDlg;

class MyFrame : public QFrame
{
   Q_OBJECT
public:
   int XPos;
   MyFrame ( QWidget * parent=0, const char * name=0, WFlags f=0, bool allowLines=TRUE );
protected:
   virtual void mousePressEvent ( QMouseEvent * );
   //virtual void paintEvent ( QPaintEvent * );
signals:
   void NeuZeichnen();
private:
   ParameterAnimDlg* AnimDlg;
};

class ParameterAnimDlg : public QDialog
{
Q_OBJECT
public:
   ParameterAnimDlg(DrawWidget* Clnt, QWidget* parent=0, const char* name=0);
   SplineCurve Spl[16];
   int CurrentSpl;
   
protected:
   void paintEvent(QPaintEvent*);

private slots:
   void ReCalc();
   void Fertig();
   void PrevBtnClick();
   void NextBtnClick();
   void EditBtnClick();
   void DisplayCheckClick();
   void LoadBtnClick();
   void SaveBtnClick();
   void TestSchlot(int);
   void StartBtnClick();
   void AbortBtnClick();
   void SplFrameUpdate();
   void CalcBtnClick();
   void CloseBtnClick();
   void PosNegCheckClick();
   void ZoomInBtnClick();
   void ZoomOutBtnClick();
   
private:
   double o,u,l,r;
   DrawWidget *Client;
   MyFrame *SplFrame;
   QPainter *Paint;
   QLabel *ParNameLab, *StatusLab, *ZoomLab;
   QWidget *ColorRect;
   QCheckBox *DisplayCheck, *PosNegCheck;
   KNumericSpinBox *NumPicSpin, *FirstImgSpin, *LastImgSpin, *IncrementSpin;
   QLineEdit *MaskEdit;
   QPushButton *StartBtn, *AbortBtn;
   QPushButton *ZoomInBtn, *ZoomOutBtn;
   KProgress *ProgressBar;
   KTabCtl* Pages;
   short DispBits;        // Anzeigebits
   void Plot(void);
   void ShowStatistic(void);
   void BerechneBild(int Nr);
   int Running;  // Anim-Berechnung luft
   int PicNr;  // aktuelles Bild
//   double Zoom;  // Vergrerungsfaktor fr die Splineanzeige
};

#endif