// #include <qapp.h>
// #include <qdialog.h>
// #include <qlabel.h>
#include <stdio.h>
#include "dlgpicset.h"
#include "dlgpicset.moc"
#define TRS klocale->translate

PicSetDlg::PicSetDlg(DrawWidget* Clnt, QWidget* parent=0, const char* name=0):
     QDialog (parent, name, WStyle_DialogBorder)
{

   setFixedSize(400,350);
   setCaption("Picture-Settings");
   Client = Clnt;

   QButtonGroup* ColorGroup = new QButtonGroup(TRS("Color Deeps"), this, "ColorGroup");
   ColorGroup->setGeometry(10,10,170,100);
   ColRadio1 = new QRadioButton(TRS("1 Bit/ 2 Colors"), ColorGroup, "ColRadio1");
   ColRadio1->setGeometry(20,20,140,18);
   ColRadio2 = new QRadioButton(TRS("8 Bit/ 256 Colors"), ColorGroup, "ColRadio2");
   ColRadio2->setGeometry(20,45,140,18);
   ColRadio3 = new QRadioButton(TRS("32 Bit/TrueColor"), ColorGroup, "ColRadio3");
   ColRadio3->setGeometry(20,70,140,18);
   switch (Client->ColorDeep) {
      case  1 : ColRadio1->setChecked(TRUE);   break;
      case  8 : ColRadio2->setChecked(TRUE);   break;
      case 32 : ColRadio3->setChecked(TRUE);   break;
   }

   QButtonGroup* SizeGroup = new QButtonGroup(TRS("Image Size"), this, "SizeGroup");
   SizeGroup->setGeometry(10,120,380,160);
   SizeXEdit = new KNumericSpinBox(SizeGroup, "SizeXEdit");
   SizeXEdit->setGeometry(80,20,80,20);
   SizeXEdit->setRange(4,2048);
   SizeXEdit->setEditable(TRUE);
   SizeXEdit->setValue(Client->GetSizeX());

   SizeYEdit = new KNumericSpinBox(SizeGroup, "SizeYEdit");
   SizeYEdit->setGeometry(270,20,80,20);
   SizeYEdit->setRange(4,2048);
   SizeYEdit->setEditable(TRUE);
   SizeYEdit->setValue(Client->GetSizeY());

   QLabel* XLab = new QLabel(TRS("SizeX :"), SizeGroup, "XLab");
   XLab->setGeometry(30,20,35,20);
   QLabel* YLab = new QLabel(TRS("SizeY :"), SizeGroup, "YLab");
   YLab->setGeometry(230,20,35,20);

   QGroupBox* DisplayGroup = new QGroupBox(TRS("Displaying"), this, "DisplayGoup");
   DisplayGroup->setGeometry(190,10,200,100);

   IntervalEdit = new KNumericSpinBox(DisplayGroup, "IntervalEdit");
//   IntervalEdit = new QNumericSpinBox(DisplayGroup, "IntervalEdit");
   IntervalEdit->setGeometry(20,65,80,20);
   IntervalEdit->setRange(1,2048);
   IntervalEdit->setEditable(TRUE);
   IntervalEdit->setValue(Client->UpdateInterval);
   QLabel* UpdLabel = new QLabel(TRS("Lines per update"), DisplayGroup, "UpdLabel");
   UpdLabel->setGeometry(20,43,175,18);

   UpdateCheck = new QCheckBox(TRS("Display during calc"), DisplayGroup, "UpdateCheck");
   UpdateCheck->setGeometry(20,20,175,20);
   UpdateCheck->setChecked(Client->UpdateBool);


   QPushButton* S320 = new QPushButton("320*240", SizeGroup, "S320");
   S320->setGeometry(30,80,80,30);
   connect(S320, SIGNAL(clicked()), this, SLOT(S320Click()) );

   QPushButton* S640 = new QPushButton("640*480", SizeGroup, "S640");
   S640->setGeometry(110,80,80,30);
   connect(S640, SIGNAL(clicked()), this, SLOT(S640Click()) );

   QPushButton* S800 = new QPushButton("800*600", SizeGroup, "S800");
   S800->setGeometry(190,80,80,30);
   connect(S800, SIGNAL(clicked()), this, SLOT(S800Click()) );

   QPushButton* S1024 = new QPushButton("1024*768", SizeGroup, "S1024");
   S1024->setGeometry(270,80,80,30);
   connect(S1024, SIGNAL(clicked()), this, SLOT(S1024Click()) );


   QPushButton* OkBtn = new QPushButton(TRS("OK"), this, "OkBtn");
   OkBtn->setGeometry(110,310,80,30);
   connect(OkBtn, SIGNAL(clicked()), this, SLOT(accept()) );

   QPushButton* DefaultsBtn = new QPushButton(TRS("Defaults"), this, "DefaultsBtn");
   DefaultsBtn->setGeometry(210,310,80,30);
   connect(DefaultsBtn, SIGNAL(clicked()), this, SLOT(SetDefaults()) );

   QPushButton* CancelBtn = new QPushButton(TRS("Cancel"), this, "CancelBtn");
   CancelBtn->setGeometry(310,310,80,30);
   connect(CancelBtn, SIGNAL(clicked()), this, SLOT(reject()) );
}

int PicSetDlg::SetValues(void)
{
int ColDeep;

   if (ColRadio1->isChecked())
      ColDeep=1;
   else
   if (ColRadio2->isChecked())
      ColDeep=8;
   else
      ColDeep=32;
   Client->ChangePicParams(SizeXEdit->getValue(),SizeYEdit->getValue(),ColDeep);

   if (IntervalEdit->getValue() > 0)
      Client->UpdateInterval = IntervalEdit->getValue();
   Client->UpdateBool = UpdateCheck->isChecked();

   return 1;
}

void PicSetDlg::S320Click()
{
   SizeXEdit->setValue(320);
   SizeYEdit->setValue(240);
}
void PicSetDlg::S640Click()
{
   SizeXEdit->setValue(640);
   SizeYEdit->setValue(480);
}
void PicSetDlg::S800Click()
{
   SizeXEdit->setValue(800);
   SizeYEdit->setValue(600);
}
void PicSetDlg::S1024Click()
{
   SizeXEdit->setValue(1024);
   SizeYEdit->setValue(768);
}
void PicSetDlg::SetDefaults()
{
   ColRadio1->setChecked(FALSE);  // 1bpp
   ColRadio2->setChecked(TRUE);   // 8bpp
   ColRadio3->setChecked(FALSE);  //32bpp
   SizeXEdit->setValue(320);
   SizeYEdit->setValue(240);
   IntervalEdit->setValue(50);
   UpdateCheck->setChecked(TRUE);
}