#include <stdio.h>
#include "dlgzoomsettings.h"
#include "dlgzoomsettings.moc"
#define TRS klocale->translate

ZoomSettingsDlg::ZoomSettingsDlg(DrawWidget* iClient, QWidget* parent=0, const char* name=0):
     QDialog (parent, name, WStyle_DialogBorder)
{
char Strg[32];

   Client = iClient;
   setFixedSize(400,350);

   QGroupBox* ZoomGrp = new QGroupBox(TRS("Zoomfactor"), this, "ZoomGrp");
   ZoomGrp->setGeometry(10,10,380,110);
   ZoomEdit = new QLineEdit(ZoomGrp, "ZoomEdit");
   ZoomEdit->setGeometry(25,25,100,25);
   sprintf(Strg,"%0.8f", Client->ZoomFactor);
   ZoomEdit->setText(Strg);
   //ZoomSlider = new KSlider(10,300,5,50,KSlider::Horizontal,ZoomGrp,"ZoomSlider");
   ZoomSlider = new KSlider(KSlider::Horizontal,ZoomGrp,"ZoomSlider");
   ZoomSlider->setRange(10,300);
   ZoomSlider->setSteps(5,20);
   ZoomSlider->setGeometry(20,60,340,20);
   ZoomSlider->setValue((int)(Client->ZoomFactor*10));
   connect(ZoomSlider, SIGNAL(valueChanged(int)), this, SLOT(ZMValChange(int)) );
   QLabel* ZMStartLab = new QLabel("1",ZoomGrp,"ZMStartLab");
   ZMStartLab->setGeometry(22,80,20,20);
   QLabel* ZMEndeLab = new QLabel("30",ZoomGrp,"ZMEndeLab");
   ZMEndeLab->setGeometry(347,80,20,20);

   QGroupBox* AnimGrp = new QGroupBox(TRS("Animationszoomfactor"), this, "AnimGrp");
   AnimGrp->setGeometry(10,135,380,160);
   AnimEdit = new QLineEdit(AnimGrp, "AnimEdit");
   AnimEdit->setGeometry(25,25,100,25);
   sprintf(Strg,"%0.8f", Client->ZoomFactorAnimation);
   AnimEdit->setText(Strg);
   AnimSlider = new KSlider(0,200,5,50,KSlider::Horizontal,AnimGrp,"AnimSlider");
   AnimSlider->setSteps(5,20);
   AnimSlider->setGeometry(20,60,340,20);
   AnimSlider->setValue( (int)((Client->ZoomFactorAnimation-1.0)*1000) );
   connect(AnimSlider, SIGNAL(valueChanged(int)), this, SLOT(ZMAnimValChange(int)) );
   QLabel* ZMAStartLab = new QLabel("1",AnimGrp,"ZMAStartLab");
   ZMAStartLab->setGeometry(22,80,20,20);
   QLabel* ZMAEndeLab = new QLabel("1.2",AnimGrp,"ZMAEndeLab");
   ZMAEndeLab->setGeometry(347,80,20,20);
   PicSpin = new KNumericSpinBox(AnimGrp, "PicSpin");
   PicSpin->setGeometry(250,25,50,25);
   PicSpin->setRange(1,30);
   PicSpin->setValue(Client->ZoomAnimationPics);

   QLabel* IterAdjLab = new QLabel(TRS("Maxiter adjust per 10 Pics"), AnimGrp, "IterAdjLab");
   IterAdjLab->setGeometry(20,110,220,20);
   IterSpin=new KNumericSpinBox(AnimGrp, "IterSpin");
   IterSpin->setGeometry(250,110,50,25);
   IterSpin->setRange(0,30);
   IterSpin->setValue(Client->IterIncrement);
   
   QPushButton* OkBtn = new QPushButton(TRS("OK"), this, "OkBtn");
   OkBtn->setGeometry(110,310,80,30);
   connect(OkBtn, SIGNAL(clicked()), this, SLOT(accept()) );

   QPushButton* DefaultsBtn = new QPushButton(TRS("Defaults"), this, "DefaultsBtn");
   DefaultsBtn->setGeometry(210,310,80,30);
   connect(DefaultsBtn, SIGNAL(clicked()), this, SLOT(SetDefaults()) );

   QPushButton* CancelBtn = new QPushButton(TRS("Cancel"), this, "CancelBtn");
   CancelBtn->setGeometry(310,310,80,30);
   connect(CancelBtn, SIGNAL(clicked()), this, SLOT(reject()) );
}

void ZoomSettingsDlg::SetDefaults()
{
   ZoomEdit->setText("5");
   ZoomSlider->setValue(50);
   AnimEdit->setText("1.03");
   AnimSlider->setValue(30);
   IterSpin->setValue(0);
}

void ZoomSettingsDlg::ZMValChange(int Val)
{
char Strg[32];
// fprintf(stdout,"ZMValChange, Val=%d\n",Val);
   sprintf(Strg,"%0.8f",0.1*Val);
   ZoomEdit->setText(Strg);
}

void ZoomSettingsDlg::ZMAnimValChange(int Val)
{
char Strg[32];
// fprintf(stdout,"ZMValChange, Val=%d\n",Val);
   sprintf(Strg,"%0.8f",0.001*Val+1.0);
   AnimEdit->setText(Strg);
}

int ZoomSettingsDlg::SetValues()
// Genderte Werte speichern
{
double ZM,ZMA;
char* eptr =NULL;

   ZM = strtod(ZoomEdit->text(), &eptr);
   if (*eptr!=0) return FALSE;

   ZMA= strtod(AnimEdit->text(), &eptr);
   if (*eptr!=0) return FALSE;

   Client->ZoomFactor = ZM;
   Client->ZoomFactorAnimation = ZMA;
   Client->ZoomAnimationPics = PicSpin->getValue();
   Client->IterIncrement = IterSpin->getValue();
   return TRUE;
}
