#ifndef GENETIC_H
#define GENETIC_H
#include <qwidget.h>
#include <qlabel.h>
#include <qpushbt.h>
#include <qdialog.h>
#include <qlined.h>
#include <qchkbox.h>
#include <kspinbox.h>
#include "basefrac.h"

class Genetic : public BaseFract
{
public:
   virtual void Init(int SizeX, int SizeY);
   virtual void SetDefaultCorners(double *x1, double *x2, double *y1, double *y2);
   virtual double SetDefaultParams(int);
   virtual int CalcPoint(int ix, int iy);
   virtual int GetFracType() { return FT_GENETIC; }
   virtual char* GetFracName(void) { return "Genetic"; }
   virtual char* GetFracInfo(void);    // Informationen ber dieses Fraktal
   virtual int SetupFrac(BaseFract* Frac); // type specific-setup
   virtual int GetSpecialParamsBytes(void);
   virtual void* GetSpecialParamsBlock(void); // Pointer auf Params, lesen
   virtual void PutSpecialParamsBlock(void);
private:

/*   void projection(vector *source, vector *control, vector *dest);
   void shift(vector *source, vector *control, vector *dest);
   void shiftback(vector *source, vector *control, vector *dest);
   void rotate(vector *source, vector *control, vector *dest);
   void rotate2(vector *source, vector *control, vector *dest);
   void multiply(vector *source, vector *control, vector *dest);
   void sine(vector *source, vector *control, vector *dest);
   void conditional(vector *source, vector *control, vector *dest);
   void complement(vector *source, vector *control, vector *dest);
   void InitTransforms(void);
   void MakeTransSequ(void);*/
};

class GeneticDlg : public QDialog
{
Q_OBJECT
public:
   GeneticDlg(BaseFract* Frac, QWidget* parent=0, const char* name=0);
   int SetSpecificParams(void);
signals:

private slots:
   void SetDefaults();
   void NoEdges();

private:
   BaseFract* Fractal;   // Pointer to the Fractal
   KNumericSpinBox *TransformSpin, *RegisterSpin;
   QCheckBox* TransCheck[9];  // die einzelnen Transformationen
};

#endif