#ifndef GINGER_H
#define GINGER_H
#include <qwidget.h>
#include <qlabel.h>
#include <qpushbt.h>
#include <qdialog.h>
#include <qlined.h>
#include <qchkbox.h>
#include "basefrac.h"

class Ginger : public BaseFract
{
public:
   virtual void Init(int SizeX, int SizeY);
   virtual void SetDefaultCorners(double *x1, double *x2, double *y1, double *y2);
   virtual double SetDefaultParams(int);
   virtual int GetFracClass(void) { return FC_ORBIT; }; // FracKlasse
   virtual void InitOrbit(void);
   virtual void CalcOrbit(void);
   virtual int GetFracType() { return FT_GINGER; }
   virtual char* GetFracName(void) { return "Gingerbreadman"; }
   virtual char* GetFracInfo(void);    // Informationen ber dieses Fraktal
   virtual int SetupFrac(BaseFract* Frac); // type specific-setup
private:
};

class GingerDlg : public QDialog
{
Q_OBJECT
public:
   GingerDlg(BaseFract* Frac, QWidget* parent=0, const char* name=0);
   int SetSpecificParams(void);
signals:

private slots:
   void SetDefaults();

private:
   BaseFract* Fractal;   // Pointer to the Fractal
   QLineEdit *ConstX, *ConstY;
   QCheckBox *VariantCheck;
};

#endif