#ifndef HENON_H
#define HENON_H
#include <qwidget.h>
#include <qlabel.h>
#include <qpushbt.h>
#include <qdialog.h>
#include <qlined.h>
#include "basefrac.h"

class Henon : public BaseFract
{
public:
   virtual void Init(int SizeX, int SizeY);
   virtual void SetDefaultCorners(double *x1, double *x2, double *y1, double *y2);
   virtual double SetDefaultParams(int);
   virtual int GetFracClass(void) { return FC_ORBIT; }; // FracKlasse
   virtual void CalcOrbit(void);
   virtual int GetFracType() { return FT_HENON; }
   virtual char* GetFracName(void) { return "Henon Attraktor"; }
   virtual char* GetFracInfo(void);    // Informationen ber dieses Fraktal
   virtual int SetupFrac(BaseFract* Frac); // type specific-setup
private:
};

class HenonDlg : public QDialog
{
Q_OBJECT
public:
   HenonDlg(BaseFract* Frac, QWidget* parent=0, const char* name=0);
   int SetSpecificParams(void);
signals:

private slots:
   void SetDefaults();

private:
   BaseFract* Fractal;   // Pointer to the Fractal
   QLineEdit *ConstX, *ConstY;
};

#endif