// Fraktaltyp Hopalong
// p[0] = pixel.x
// p[1] = pixel.y
#include <stdio.h>
#include <stdlib.h>
#include "hop.h"
#include "hop.moc"
#define TRS klocale->translate

double HopPar[3] = {0.4, 1, 0.1};

void Hop::Init(int SizeX, int SizeY)
{
int i;

   BaseFract::Init(SizeX, SizeY);
   SetDefaultCorners(&li,&re,&un,&ob);
   for (i=0; i<16;i++) p[i]=SetDefaultParams(i);
   SetSize(SizeX, SizeY);
}

void Hop::SetDefaultCorners(double *x1, double *x2, double *y1, double *y2)
{
   *x1 = -20;
   *x2 =  20;
   *y1 = -16;
   *y2 =  16;
}

double Hop::SetDefaultParams(int Index)
{
   if (Index<0) return 0.0;
   if (Index >= 3) return 0.0;
   return HopPar[Index];
}

void Hop::InitOrbit(void) {
   OrbX = p[0];
   OrbY = p[1];
}

void Hop::CalcOrbit(void)
// Berechnung fr orbitale Tpen
{
// Orbit
double h;

   h = OrbY - sign(OrbX)*sqrt(fabs(p[1]*OrbX-p[2]));
   OrbY = p[0]-OrbX;
   OrbX = h;
}


char* Hop::GetFracInfo(void)
{
   return "Formula: X=A;  Y=B\n X=Y-sign(X)*sqrt(fabs(B*X-C))\nY=A-X";
}

int Hop::SetupFrac(BaseFract* Frac) // type specific-setup
{
HopDlg HDlg = HopDlg(Frac, 0, "Hop settings");

   if (HDlg.exec()) {
      return HDlg.SetSpecificParams();
   } else
      return FALSE;
}


// -----------------------------------------

HopDlg::HopDlg(BaseFract* Frac, QWidget* parent=0, const char* name=0):
          QDialog(parent,name, WStyle_DialogBorder)
{
char Strg[32];
   Fractal = Frac;
   setFixedSize(300,200);
   setCaption(Fractal->GetFracName());

   QLabel *Label0 = new QLabel(TRS("Constant Values"), this, "Label0");
   Label0->setGeometry(30,20,150,20);

   ConstX = new QLineEdit(this, "ConstX");
   ConstX->setGeometry(100,50,125,22);
   sprintf(Strg,"%0.14f", Fractal->p[0]);
   ConstX->setText(Strg);
   ConstY = new QLineEdit(this, "ConstY");
   ConstY->setGeometry(100,80,125,22);
   sprintf(Strg,"%0.14f", Fractal->p[1]);
   ConstY->setText(Strg);
   ConstZ = new QLineEdit(this, "ConstZ");
   ConstZ->setGeometry(100,110,125,22);
   sprintf(Strg,"%0.14f", Fractal->p[2]);
   ConstZ->setText(Strg);

   QLabel* Label1 = new QLabel("A",this,"Label1");
   Label1->setGeometry(20,50,75,20);
   QLabel* Label2 = new QLabel("B",this,"Label2");
   Label2->setGeometry(20,80,75,20);
   QLabel* Label3 = new QLabel("C",this,"Label3");
   Label3->setGeometry(20,110,75,20);

   QPushButton* OkBtn = new QPushButton(TRS("OK"), this, "OkBtn");
   OkBtn->setGeometry(20,150,80,30);
   OkBtn->setDefault(TRUE);
   connect(OkBtn,SIGNAL(clicked()), this, SLOT(accept()) );

   QPushButton* DefaultsBtn = new QPushButton(TRS("Defaults"), this, "DefautsBtn");
   DefaultsBtn->setGeometry(110,150,80,30);
   connect(DefaultsBtn,SIGNAL(clicked()), this, SLOT(SetDefaults()) );

   QPushButton* CancelBtn = new QPushButton(TRS("Cancel"), this, "OkBtn");
   CancelBtn->setGeometry(200,150,80,30);
   connect(CancelBtn,SIGNAL(clicked()), this, SLOT(reject()) );
}

int HopDlg::SetSpecificParams(void)
{
char* eptr;
double p0,p1,p2;

   p0 = strtod(ConstX->text(), &eptr);
   if (*eptr!=0) return FALSE;

   p1 = strtod(ConstY->text(), &eptr);
   if (*eptr!=0) return FALSE;

   p2 = strtod(ConstZ->text(), &eptr);
   if (*eptr!=0) return FALSE;

   Fractal->p[0] = p0;
   Fractal->p[1] = p1;
   Fractal->p[2] = p2;
   return TRUE;
}

void HopDlg::SetDefaults()
{
char Strg[32];

   sprintf(Strg,"%0.14f", Fractal->SetDefaultParams(0));
   ConstX->setText(Strg);
   sprintf(Strg,"%0.14f", Fractal->SetDefaultParams(1));
   ConstY->setText(Strg);
   sprintf(Strg,"%0.14f", Fractal->SetDefaultParams(2));
   ConstZ->setText(Strg);
}