#ifndef INSEL_H
#define INSEL_H
#include <qwidget.h>
#include <qlabel.h>
#include <qpushbt.h>
#include <qdialog.h>
#include <qlined.h>
#include <qchkbox.h>
#include <kspinbox.h>
#include "basefrac.h"
#include "kmandel.h"

typedef int FeldTyp[129][129];

class Insel : public BaseFract
{
public:
   virtual void Init(int SizeX, int SizeY);
   virtual void ReInit(void);
   virtual void SetDefaultCorners(double *x1, double *x2, double *y1, double *y2);
   virtual int GetFracClass(void) { return FC_IAO; }; // FracKlasse
   virtual double SetDefaultParams(int);
   virtual void InitIAO(void);
   virtual void CalcIAO(void);
   virtual int GetFracType() { return FT_INSEL; }
   virtual char* GetFracName(void) { return "Insel"; }
   virtual char* GetFracInfo(void);    // Informationen ber dieses Fraktal
   virtual int SetupFrac(BaseFract* Frac); // type specific-setup
private:
   void InitInsel(void);
//   int WasserStand, InselFaktor, InselNr;
   FeldTyp Feld1,Feld2;

   void BerechneInsel(void);      
   long CalcFarbe(int z1, int z2, int z3, int z4);
   void InselDarstellen(void);
};

class InselDlg : public QDialog
{
Q_OBJECT
public:
   InselDlg(BaseFract* Frac, QWidget* parent=0, const char* name=0);
   int SetSpecificParams(void);

private slots:
   void SetDefaults();

private:
   BaseFract* Fractal;   // Pointer to the Fractal
   QLineEdit *ScaleEdit;
   KNumericSpinBox *InselNrSpin, *WasserSpin, *HoeheSpin;
   QCheckBox *HorCheck, *VertCheck;
};

#endif