#ifndef JULIA_N_H
#define JULIA_N_H
#include <qwidget.h>
#include <qlabel.h>
#include <qpushbt.h>
#include <qdialog.h>
#include <qlined.h>
#include <qchkbox.h>
#include <kspinbox.h>
#include "basefrac.h"

class JuliaHochN : public BaseFract
{
public:
   virtual void Init(int SizeX, int SizeY);
   virtual void SetDefaultCorners(double *x1, double *x2, double *y1, double *y2);
   virtual double SetDefaultParams(int);
   virtual int CalcPoint(int x, int y);
   virtual int GetFracType() { return FT_JULIA_N; }
   virtual char* GetFracName(void) { return "Julia_hoch_n"; }
   virtual char* GetFracInfo(void);    // Informationen ber dieses Fraktal
   virtual int SetupFrac(BaseFract* Frac); // type specific-setup
private:
};

class JuliaHochNDlg : public QDialog
{
Q_OBJECT
public:
   JuliaHochNDlg(BaseFract* Frac, QWidget* parent=0, const char* name=0);
   int SetSpecificParams(void);
signals:

private slots:
   void SetDefaults();

private:
   BaseFract* Fractal;   // Pointer to the Fractal
   QLineEdit *ConstX, *ConstY, *PotX, *PotY;
   //KNumericSpinBox* PotSpin;
};

#endif