#ifndef LJULIA_H
#define LJULIA_H
#include <qwidget.h>
#include <qlabel.h>
#include <qpushbt.h>
#include <qdialog.h>
#include <qlined.h>
#include "basefrac.h"

class LJulia : public BaseFract
{
public:
   virtual void Init(int SizeX, int SizeY);
   virtual void SetDefaultCorners(double *x1, double *x2, double *y1, double *y2);
   virtual double SetDefaultParams(int Index);
   virtual int CalcPoint(int x, int y);
   virtual int GetFracType() { return FT_JLAMBDA; }
   virtual char* GetFracName() { return "Lambda-Julia"; }
   virtual char* GetFracInfo();
   virtual int SetupFrac(BaseFract* Frac);
private:
};

class LJuliaDlg : public QDialog
{
Q_OBJECT
public:
   LJuliaDlg(BaseFract* Frac, QWidget* parent=0, const char* name=0);
   int SetSpecificParams(void);
signals:

private slots:
   void SetDefaults();
   
private:
   BaseFract* Fractal;   // Pointer to the Fractal
   QLineEdit *ConstX, *ConstY;
};

#endif