#ifndef LMANDEL_H
#define LMANDEL_H
#include "basefrac.h"

class LMandel : public BaseFract
{
public:
   virtual void Init(int SizeX, int SizeY);
   virtual void SetDefaultCorners(double *x1, double *x2, double *y1, double *y2);
   virtual double SetDefaultParams(int Index);
   virtual int CalcPoint(int x, int y);
   virtual int GetFracType() { return FT_MLAMBDA; }
   virtual char* GetFracName(void) { return "Lambda-Mandelbrot"; }
   virtual char* GetFracInfo(void);
   virtual int SetupFrac(BaseFract* Frac);
private:
};

class LMandelDlg : public QDialog
{
Q_OBJECT
public:
   LMandelDlg(BaseFract* Frac, QWidget* parent=0, const char* name=0);
   int SetSpecificParams(void);
signals:

private slots:
   void SetDefaults();

private:
   BaseFract* Fractal;   // Pointer to the Fractal
   QLineEdit *OffsetX, *OffsetY;
};

#endif