// Fraktaltyp Liapi
// p[0] = pixel.x
// p[1] = pixel.y
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "liapi.h"
#include "liapi.moc"
#define LOG2 0.6931471806
#define BIG 100000.0
#define TRS klocale->translate

double LiapiPar[4] = {0.5, 256, 5.0, 1000.0};

void Liapi::Init(int SizeX, int SizeY)
{
int i;

   BaseFract::Init(SizeX, SizeY);
   SetDefaultCorners(&li,&re,&un,&ob);
   for (i=0; i<16;i++) p[i]=SetDefaultParams(i);
   sprintf(s[0],"ab");
   SeqLen = 2;
   SetSize(SizeX, SizeY);
   l[0]=5;
   //lya_setup();
}

void Liapi::SetDefaultCorners(double *x1, double *x2, double *y1, double *y2)
{
   *x1 =  1;     // Gre des Fraktals
   *x2 =  4;
   *y1 =  4;
   *y2 =  1;
}

double Liapi::SetDefaultParams(int Index)
{
   if (Index<0) return 0.0;
   if (Index >= 4) return 0.0;
   return LiapiPar[Index];
}

/*int Liapi::CalcPoint(int x, int y)
{
double rx = li+dx*x;
double ry = un+dy*y;
double r,t,total;
int    iter=0;
int    idx=0;

   t = p[0];
   total = 0.0;
   //SeqLen = strlen(s[0]);
   
   for (iter=0; iter<MaxIter; iter++) {
      r = (s[0][idx]=='a')? rx:ry;
      t = t*(1.0-t)*r;
      idx++;  
      //if (idx>=SeqLen) idx=0;
      if (s[0][idx]==0) idx=0;   // Ende der Sequenz ?
      total += log(fabs(r - 2.0*r*t))/LOG2;
      //fprintf(stdout,"%10.5f",total);
   }
   //fprintf(stdout,"\n");
   //if (total > 0) iter = 0;
   //else
   //   iter=(-total);
   if (p[2]==0.0) p[2]=1.0;
   if (total>0.0)
      iter = (int) (total/p[2]);
   else {
      if (-total > p[3])
         total = -p[3];
      iter = (int) (p[1]+(-total/p[2]));
   }
   if (iter<0) iter=0;
   return iter;
}*/

void Liapi::InitField (void) {
    /* This routine sets up the sequence for forcing the Rate parameter
	to vary between the two values.  It fills the array lyaRxy[] and
	sets lyaLength to the length of the sequence.

	The sequence is coded in the bit pattern in an integer.
	Briefly, the sequence starts with an A the leading zero bits
	are ignored and the remaining bit sequence is decoded.  The
	sequence ends with a B.  Not all possible sequences can be
	represented in this manner, but every possible sequence is
	either represented as itself, as a rotation of one of the
	representable sequences, or as the inverse of a representable
	sequence (swapping 0s and 1s in the array.)  Sequences that
	are the rotation and/or inverses of another sequence will generate
	the same lyapunov exponents.

	A few examples follow:
	    number    sequence
  		0	ab
  		1	aab
  		2	aabb
  		3	aaab
  		4	aabbb
  		5	aabab
  		6	aaabb (this is a duplicate of 4, a rotated inverse)
  		7	aaaab
  		8	aabbbb	etc.
	 */

//    long i;
    int t;

//fprintf(stdout,"lya_setup - Start\n");
    if ((filter_cycles=l[0])==0)
	filter_cycles=MaxIter/2;
/*
    lyaLength = 1;

    i = (int)p[1];

    lyaRxy[0] = 1;
    for (t=31; t>=0; t--)
	if (i & (1<<t)) break;
    for (; t>=0; t--)
	lyaRxy[lyaLength++] = (i & (1<<t)) != 0;
    lyaRxy[lyaLength++] = 0;
*/    
    lyaLength = strlen(s[0]);
    SeqLen = lyaLength;
    for(t=0; t<lyaLength; t++)
       lyaRxy[t] = (s[0][t]=='b');
/*fprintf(stdout,"lya_setup - Ende\n");
for(t=lyaLength;t>0;t--)
   fprintf(stdout,"%d ",lyaRxy[t]);
fprintf(stdout,"\n");
*/
}

int Liapi::CalcPoint(int x, int y)
{
double rx = li+dx*x;
double ry = un+dy*y;
double total;
int    iter=0;

 
    int color, count, lnadjust, overflow=0;
    long i;
    double lyap, temp, Rate;
    double Population = p[0];
    
    // e10=22026.4657948  e-10=0.0000453999297625 
//fprintf(stdout,"lya_calc - Start\n");
//printf("YMin=%f,YMax=%f,rx=%f,ry=%f,dy=%f\n",un,ob,rx,ry,dy);
//fprintf(stdout,"fc=%d  sq=%d\n",filter_cycles,SeqLen);
    total = 1.0;
    lnadjust = 0;
    //SeqLen=strlen(s[0]);
    for (i=0; i<filter_cycles; i++) {
	for (count=0; count<SeqLen; count++) {
	    Rate = lyaRxy[count] ? rx : ry;
	    //Rate = (s[0][count]=='b') ? rx : ry;
	    Population = Rate * Population * (1 - Population);

	    if (fabs(Population) > BIG) {
		overflow = TRUE;
		goto jumpout;
            }
	}
    }
//fprintf(stdout,"between for\n");
    for (i=0; i < MaxIter/2; i++) {
	for (count = 0; count<SeqLen ; count++) {
	    Rate = lyaRxy[count] ? rx : ry;
	    //Rate = (s[0][count]=='b') ? rx : ry;
	    Population = Rate * Population * (1 - Population);

	    if (fabs(Population) > BIG) {
		overflow = TRUE;
		goto jumpout;
		}
	    temp = fabs(Rate-2.0*Rate*Population);
		if ((total *= (temp))==0) {
		overflow = TRUE;
		goto jumpout;
		}
	    }
	while (total > 22026.4657948) {
	    total *= 0.0000453999297625;
	    lnadjust += 10;
	    }
	while (total < 0.0000453999297625) {
	    total *= 22026.4657948;
	    lnadjust -= 10;
	    }
	}

jumpout:
//fprintf(stdout,"liapi durch\n");
    if (overflow || total <= 0 || (temp = log(total) + lnadjust) > 0)
	color = 0;
    else {
	//if (LogFlag)
	//lyap = -temp/((double) lyaLength*i);
        //else
	lyap = 1 - exp(temp/((double) lyaLength*i));
	color = 1 + (int)(lyap * p[1]);
   }
//fprintf(stdout,"lya_calc - Ende\n");

    return color;

   return iter;
}

char* Liapi::GetFracInfo(void)
{
   return "?";
}

int Liapi::SetupFrac(BaseFract* Frac) // type specific-setup
{
LiapiDlg MDlg = LiapiDlg(Frac, 0, "Liapi settings");
int Bool;

   if (MDlg.exec()) {
      Bool = MDlg.SetSpecificParams();
   } else
      Bool= FALSE;
   //if (Bool)
   //   lya_setup();
   return Bool;   
}


// -----------------------------------------

LiapiDlg::LiapiDlg(BaseFract* Frac, QWidget* parent=0, const char* name=0):
          QDialog(parent,name, WStyle_DialogBorder)
{
char Strg[32];
int i;
QLabel* Lab[4];

   Fractal = Frac;
   setFixedSize(300,280);
   setCaption(Fractal->GetFracName());

   QLabel *Label0 = new QLabel(TRS("Lyapunov Parameters"), this, "Label0");
   Label0->setGeometry(30,20,150,20);

   SeqEdit = new QLineEdit(this, "SeqEdit");
   SeqEdit->setGeometry(120,50,125,22);
   SeqEdit->setText(Fractal->s[0]);
   
   SeedEdit = new QLineEdit(this, "SeedEdit");
   SeedEdit->setGeometry(120,80,125,22);
   sprintf(Strg,"%0.14f", Fractal->p[0]);
   SeedEdit->setText(Strg);

   ColorEdit = new QLineEdit(this, "ColorEdit");
   ColorEdit->setGeometry(120,110,125,22);
   sprintf(Strg,"%0.10f", Fractal->p[1]);
   ColorEdit->setText(Strg);

   FilterSpin = new KNumericSpinBox(this, "FilterSpin");
   FilterSpin->setGeometry(120,140,125,22);
   FilterSpin->setRange(0,1000);
   FilterSpin->setEditable(TRUE);
   FilterSpin->setValue(Fractal->l[0]);
   
   for (i=0;i<4;i++) {
      Lab[i] = new QLabel("",this,"Label");
      Lab[i]->setGeometry(20,50+30*i,95,20);
   }
   Lab[0]->setText(TRS("Sequence"));
   Lab[1]->setText(TRS("Initial"));
   Lab[2]->setText(TRS("Color Scale"));
   Lab[3]->setText(TRS("Filter"));


   QPushButton* OkBtn = new QPushButton(TRS("OK"), this, "OkBtn");
   OkBtn->setGeometry(20,230,80,30);
   OkBtn->setDefault(TRUE);
   connect(OkBtn,SIGNAL(clicked()), this, SLOT(accept()) );

   QPushButton* DefaultsBtn = new QPushButton(TRS("Defaults"), this, "DefautsBtn");
   DefaultsBtn->setGeometry(110,230,80,30);
   connect(DefaultsBtn,SIGNAL(clicked()), this, SLOT(SetDefaults()) );

   QPushButton* CancelBtn = new QPushButton(TRS("Cancel"), this, "OkBtn");
   CancelBtn->setGeometry(200,230,80,30);
   connect(CancelBtn,SIGNAL(clicked()), this, SLOT(reject()) );
}

int LiapiDlg::SetSpecificParams(void)
{
char* eptr;
double p0,p1;

   p0 = strtod(SeedEdit->text(), &eptr);
   if (*eptr!=0) return FALSE;
   p1 = strtod(ColorEdit->text(), &eptr);
   if (*eptr!=0) return FALSE;

   Fractal->p[0] = p0;
   Fractal->p[1] = p1;
   Fractal->l[0] = FilterSpin->getValue();
   sprintf(Fractal->s[0],"%s", SeqEdit->text());
   
   return TRUE;
}

void LiapiDlg::SetDefaults()
{
char Strg[32];

   sprintf(Strg,"%0.14f", Fractal->SetDefaultParams(0));
   SeedEdit->setText(Strg);
   sprintf(Strg,"%0.14f", Fractal->SetDefaultParams(1));
   ColorEdit->setText(Strg);
   FilterSpin->setValue(5);
   SeqEdit->setText("ab");
}