#ifndef LIAPI_H
#define LIAPI_H
#include <qwidget.h>
#include <qlabel.h>
#include <qpushbt.h>
#include <qdialog.h>
#include <qlined.h>
#include <qchkbox.h>
#include <kspinbox.h>
#include "basefrac.h"

class Liapi : public BaseFract
{
public:
   virtual void Init(int SizeX, int SizeY);
   virtual void SetDefaultCorners(double *x1, double *x2, double *y1, double *y2);
   virtual double SetDefaultParams(int);
   virtual void InitField(void);
   virtual int CalcPoint(int x, int y);
   virtual int GetFracType() { return FT_LIAPI; }
   virtual char* GetFracName(void) { return "Liapi"; }
   virtual char* GetFracInfo(void);    // Informationen ber dieses Fraktal
   virtual int SetupFrac(BaseFract* Frac); // type specific-setup
   void lya_setup (void);
private:
   int SeqLen;            // Lnge der Sequenz
   int lyaLength;
   long filter_cycles;
   int lyaRxy[64];

};

class LiapiDlg : public QDialog
{
Q_OBJECT
public:
   LiapiDlg(BaseFract* Frac, QWidget* parent=0, const char* name=0);
   int SetSpecificParams(void);
signals:

private slots:
   void SetDefaults();

private:
   BaseFract* Fractal;   // Pointer to the Fractal
   QLineEdit *SeedEdit, *ColorEdit, *SeqEdit;
   KNumericSpinBox* FilterSpin;
};

#endif