// Orbitaltyp Orbit 3
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "mymath.h"
#include "orbit3.h"
#include "orbit3.moc"
#define TRS klocale->translate

double Orbit3Par[4] = {2.24, 0.43, -0.65, -2.43};

void Orbit3::Init(int SizeX, int SizeY)
{
int i;

   BaseFract::Init(SizeX, SizeY);
   SetDefaultCorners(&li,&re,&un,&ob);
   for (i=0; i<16;i++) p[i]=SetDefaultParams(i);
   SetSize(SizeX, SizeY);
}

void Orbit3::SetDefaultCorners(double *x1, double *x2, double *y1, double *y2)
{
   *x1 = -2.8;
   *x2 =  2.8;
   *y1 = -2.0;
   *y2 =  2.0;
}

double Orbit3::SetDefaultParams(int Index)
{
   if (Index<0) return 0.0;
   if (Index >= 4) return 0.0;
   return Orbit3Par[Index];
}

void Orbit3::CalcOrbit(void)
// Berechnung fr orbitale Tpen
{
double h1,h2;

   h1 = sin(p[0]*OrbY) - OrbZ*cos(p[1]*OrbX);
   h2 = OrbZ*sin(p[2]*OrbX) - cos(p[3]*OrbY);
   OrbZ = sin(OrbX);
   OrbX = h1;
   OrbY = h2;
}


char* Orbit3::GetFracInfo(void)
{
   return 
"Orbit in three dimensions\nFormula:\n\n\
X(n+1) = sin(p0*Y(n)) - Z(n)*cos(p1*X(n))\n\
Y(n+1) = Z(n)*sin(p2*X(n)) - cos(p3*Y(n))\n\
Z(n+1) = sin(X(n))\n\n\
Four parameters: p0, p1, p2, p3.\n";
}

int Orbit3::SetupFrac(BaseFract* Frac) // type specific-setup
{
Orbit3Dlg GDlg = Orbit3Dlg(Frac, 0, "Orbit3 settings");

   if (GDlg.exec()) {
      return GDlg.SetSpecificParams();
   } else
      return FALSE;
}


// -----------------------------------------

Orbit3Dlg::Orbit3Dlg(BaseFract* Frac, QWidget* parent=0, const char* name=0):
          QDialog(parent,name, WStyle_DialogBorder)
{
char Strg[32];
int Lauf;
QLabel *Lab[4];

   Fractal = Frac;
   setFixedSize(300,250);
   setCaption(Fractal->GetFracName());

   QLabel *Label0 = new QLabel(TRS("Parameters"), this, "Label0");
   Label0->setGeometry(30,20,150,20);

   for (Lauf=0; Lauf<4; Lauf++) {
      Par[Lauf] = new QLineEdit(this, "ConstX");
      Par[Lauf]->setGeometry(100,50+Lauf*30,125,22);
      sprintf(Strg,"%0.14f", Fractal->p[Lauf]);
      Par[Lauf]->setText(Strg);
      
      sprintf(Strg,"p%d", Lauf);
      Lab[Lauf] = new QLabel(Strg, this, Strg);
      Lab[Lauf]->setGeometry(20,50+Lauf*30,75,20);
   }


   QPushButton* OkBtn = new QPushButton(TRS("OK"), this, "OkBtn");
   OkBtn->setGeometry(20,200,80,30);
   OkBtn->setDefault(TRUE);
   connect(OkBtn,SIGNAL(clicked()), this, SLOT(accept()) );

   QPushButton* DefaultsBtn = new QPushButton(TRS("Defaults"), this, "DefautsBtn");
   DefaultsBtn->setGeometry(110,200,80,30);
   connect(DefaultsBtn,SIGNAL(clicked()), this, SLOT(SetDefaults()) );

   QPushButton* CancelBtn = new QPushButton(TRS("Cancel"), this, "OkBtn");
   CancelBtn->setGeometry(200,200,80,30);
   connect(CancelBtn,SIGNAL(clicked()), this, SLOT(reject()) );
}

int Orbit3Dlg::SetSpecificParams(void)
{
char* eptr;
double p[4];
int Lauf;

   for(Lauf=0; Lauf<4; Lauf++) {
      p[Lauf] = strtod(Par[Lauf]->text(), &eptr);
      if (*eptr!=0) return FALSE;
   }

   for (Lauf=0; Lauf<4; Lauf++)
      Fractal->p[Lauf] = p[Lauf];
   return TRUE;
}

void Orbit3Dlg::SetDefaults()
{
char Strg[32];
int Lauf;

   for(Lauf=0; Lauf<4; Lauf++) {
      sprintf(Strg,"%0.14f", Fractal->SetDefaultParams(Lauf));
      Par[Lauf]->setText(Strg);
   }
}