#ifndef ORBIT3_H
#define ORBIT3_H
#include <qwidget.h>
#include <qlabel.h>
#include <qpushbt.h>
#include <qdialog.h>
#include <qlined.h>
#include "basefrac.h"

class Orbit3 : public BaseFract
{
public:
   virtual void Init(int SizeX, int SizeY);
   virtual void SetDefaultCorners(double *x1, double *x2, double *y1, double *y2);
   virtual double SetDefaultParams(int);
   virtual int GetFracClass(void) { return FC_ORBIT; }; // FracKlasse
   virtual void CalcOrbit(void);
   virtual int GetFracType() { return FT_ORBIT3; }
   virtual char* GetFracName(void) { return "Orbit3 Attraktor"; }
   virtual char* GetFracInfo(void);    // Informationen ber dieses Fraktal
   virtual int SetupFrac(BaseFract* Frac); // type specific-setup
private:
};

class Orbit3Dlg : public QDialog
{
Q_OBJECT
public:
   Orbit3Dlg(BaseFract* Frac, QWidget* parent=0, const char* name=0);
   int SetSpecificParams(void);
signals:

private slots:
   void SetDefaults();

private:
   BaseFract* Fractal;   // Pointer to the Fractal
   QLineEdit *Par[4];
};

#endif