#include "parameter.h"

// Herderstruktur fr einen Block
struct HeaderType {
   char Kenn1,Kenn2;
   unsigned short int Laenge;
};

ParameterFile::ParameterFile(const char* DN)
{
   DateiName = strdup(DN);
   FileMode  = PAR_CLOSE;
fprintf(stdout,"Create: Dateiname = %s\n",DateiName);
}

int ParameterFile::Open(int Mode)
// ffnet die Datei fr Zugriffe.
// Mode gibt den Zugriffsmodus an, PAR_READ zum lesen, PAR_WRITE zum schriben
// Trat beim ffnen ein Fehler auf, wird ein negativer Wert zurckgegeben,
// sonst PAR_OK.
{
   if (Mode == PAR_WRITE) {
      Datei = fopen(DateiName, "wb");  // zum schreiben ffnen
      FileMode = PAR_WRITE;
   } else {
      Datei = fopen(DateiName, "rb");  // lesen
      FileMode = PAR_READ;
   }
   if (!Datei) {    // ffnen fehlgeschlagen
      FileMode = PAR_CLOSE;
      return PAR_OPENERR;
   }
   return PAR_OK;
}

int ParameterFile::BlockSize(char K1, char K2)
// Blockgre ermitteln
{
struct HeaderType Header;
int Res, Posi;

fprintf(stdout,"suche %c%c\n",K1,K2);
   if (FileMode != PAR_READ) return PAR_ERROR;   // kein Lesezugriff
   Posi = 0;                              // Seek-Position in der Datei
   do {
      fseek(Datei, Posi, SEEK_SET);             // Dateianfang
      Res = fread(&Header, sizeof(Header), 1, Datei);  // Header lesen
fprintf(stdout,"Header = %c%c, size = %d\n",Header.Kenn1, Header.Kenn2, Header.Laenge);
      if ((Header.Kenn1 == 'E') && (Header.Kenn2 == 'D'))
         return PAR_NOTFOUND;     // Ende-Header erreicht, keine weiteren Daten
      if ((Header.Kenn1 == K1) && (Header.Kenn2 == K2)) {
fprintf(stdout,"jefunden\n");
         return Header.Laenge;    // Header gefunden, Lnge zurckgeben
      }
      Posi = Posi + 4 + Header.Laenge;

      if (feof(Datei)) return PAR_ERROR; // Header nicht gefunden und kein Ende-Header
                                  // mglicherweise ist die Datei defekt !!
   } while (1); //endlos....
   return PAR_ERROR;
}

int ParameterFile::ReadBlock(char K1, char K2, void* Data, int Size)
// Block lesen
{
int Res;

   Res = BlockSize(K1,K2);
   if (Res < 0) return Res;
   Res = fread(Data, Size, 1, Datei);
   if (Res != 1)
      return PAR_ERROR;
   return PAR_OK;
}

int ParameterFile::WriteBlock(char K1, char K2, void* Data, int Length)
{
struct HeaderType Header;
int Res;

   if (FileMode != PAR_WRITE)     // Datei ist nicht fr Schreiben vorbereitet.
      return PAR_ERROR;
   Header.Kenn1 = K1;
   Header.Kenn2 = K2;
   Header.Laenge = Length;
   Res = fwrite(&Header, sizeof(Header), 1, Datei);   // Header schreiben
fprintf(stdout,"Header: res = %d\n",Res);
   if (Res < 1) return PAR_ERROR;   // Fehler beim Schreiben
   Res = fwrite(Data, Length, 1, Datei);
fprintf(stdout,"Data: res = %d\n",Res);
   if (Res < 1) return PAR_ERROR;   // Fehler beim Schreiben

   return PAR_OK;
}

void ParameterFile::Close()
{
struct HeaderType Header;
   // Ende-Block schreiben, falls Datei im Schreibmodus
   if (FileMode==PAR_WRITE) {
      Header.Kenn1 = 'E';
      Header.Kenn2 = 'D';
      Header.Laenge = 0;
      fwrite(&Header, sizeof(Header), 1, Datei);
   }
   fclose(Datei);
   FileMode = PAR_CLOSE;
}

ParameterFile::~ParameterFile()
{
   free(DateiName);
   FileMode = PAR_CLOSE;
}
