#ifndef PARAMETER_H
#define PARAMETER_H
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qapp.h>

// Constants for reading or writing the parameter-files
#define PAR_NOTFOUND -4      // gesuchten Block nicht gefunden
#define PAR_OPENERR -3       // Fehler beim ffnen der Datei
#define PAR_ERROR -2         // Fhler
#define PAR_CLOSE -1         // Datei nicht offen
#define PAR_OK 0             // kein Fehler
#define PAR_READ  1          // lesen
#define PAR_WRITE 2          // schriben

/**
* ParameterFile
* @author CFJH
* @version 0.1
*/
class ParameterFile
{
public:
   ParameterFile(const char* DN);   // Initlialisieren
   /**
   * Datei ffnen
   * @param mode
   */
   int Open(int Mode);              // Datei ffnen
   int WriteBlock(char K1, char K2, void* Data, int Length); // Block speichern
   int BlockSize(char K1, char K2); // Blockgre ermitteln
   int ReadBlock(char K1, char K2, void* Data, int Size); // Block lesen
   void Close();                    // Datei schlieen
   ~ParameterFile();                // Freigeben
private:
   char* DateiName;
   int FileMode;    // Satus der Datei
   FILE* Datei;
};
#endif