// Fraktaltyp Pheonix
// p[0] = pixel.x
// p[1] = pixel.y
#include <stdio.h>
#include <stdlib.h>
#include <qmsgbox.h>
#include "komplex.h"
#include "pheonix.h"
#define TRS klocale->translate

double PheonixPar[2] = {0, 0.0};

void Pheonix::Init(int SizeX, int SizeY)
{
int i;

   BaseFract::Init(SizeX, SizeY);
   SetDefaultCorners(&li,&re,&un,&ob);
   for (i=0; i<16;i++) p[i]=SetDefaultParams(i);
   SetSize(SizeX, SizeY);
}

void Pheonix::SetDefaultCorners(double *x1, double *x2, double *y1, double *y2)
{
   *x1 = -2;     // Gre des Fraktals
   *x2 =  2;
   *y1 = -1.5;
   *y2 =  1.5;
}

double Pheonix::SetDefaultParams(int Index)
{
   if (Index<0) return 0.0;
   if (Index >= 2) return 0.0;
   return PheonixPar[Index];
}

int Pheonix::CalcPoint(int x, int y)
{
double rx = li+dx*x;
double ry = un+dy*y;
int    iter=0;
struct komplex z,zp1,zp2,temp;

  z.re=rx; z.im=ry;
  zp1.re=0.0; zp1.im=0.0;
  zp2=zp1;
  do {
    temp=z;
    z = cmul(z,z);
    z = csub(z,zp2);
    zp2 = zp1;
    zp1 = temp;
    zp1.im = -zp1.im;
    iter++;
//  } while ( (iter<MaxIter) && (zp1.re*zp1.re+zp1.im*zp1.im < 4.0) );
  } while ( (iter<MaxIter) && ConvTest(zp1.re*zp1.re,zp1.im*zp1.im) );

  return PostCompute(iter, zp1.re, zp1.im);
}

char* Pheonix::GetFracInfo(void)
{
   return "Formula: x=c=Pixel;\n     loop {x=x^2+c};\n     until (x^2>Bail)";
}

int Pheonix::SetupFrac(BaseFract*) // type specific-setup
{
/*MaDlg MDlg = MandelBrotDlg(Frac, 0, "Mandelbrot settings");

   if (MDlg.exec()) {
      return MDlg.SetSpecificParams();
   } else
      return FALSE;
*/
   QMessageBox::information(NULL,TRS("No Parameters"),
                   TRS("This type has no changable parameters"),
                   QMessageBox::Ok);

return 0;
}
