#ifndef POCKEN_H
#define POCKEN_H
#include <qwidget.h>
#include <qlabel.h>
#include <qpushbt.h>
#include <qdialog.h>
#include <qlined.h>
#include <qchkbox.h>
#include <kspinbox.h>
#include "basefrac.h"

class Pocken : public BaseFract
{
public:
   virtual void Init(int SizeX, int SizeY);
   virtual void SetDefaultCorners(double *x1, double *x2, double *y1, double *y2);
   virtual double SetDefaultParams(int);
   virtual int CalcPoint(int ix, int iy);
   virtual int GetFracType() { return FT_POCKEN; }
   virtual char* GetFracName(void) { return "Pocken"; }
   virtual char* GetFracInfo(void);    // Informationen ber dieses Fraktal
   virtual int SetupFrac(BaseFract* Frac); // type specific-setup
   virtual int GetSpecialParamsBytes(void); // Size
   virtual void* GetSpecialParamsBlock(void); // Pointer auf Params, lesen
   virtual void PutSpecialParamsBlock(void);  // write
private:
   void InitPocken(void);
};

class PockenDlg : public QDialog
{
Q_OBJECT
public:
   PockenDlg(BaseFract* Frac, QWidget* parent=0, const char* name=0);
   int SetSpecificParams(void);

private slots:
   void SetDefaults();

private:
   BaseFract* Fractal;   // Pointer to the Fractal
   QLineEdit *ScaleEdit;
   KNumericSpinBox *PointsSpin;
};

#endif