// Fraktaltyp Quadtat
// p[0] = pixel.x
// p[1] = pixel.y
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "quadrat.h"
#define TRS klocale->translate

double QuadratPar[2] = {3.141592, 0};

void Quadrat::Init(int SizeX, int SizeY)
{
int i;

   BaseFract::Init(SizeX, SizeY);
   SetDefaultCorners(&li,&re,&un,&ob);
   for (i=0; i<16;i++) p[i]=SetDefaultParams(i);
   l[0] = 0;
   SetSize(SizeX, SizeY);
}

void Quadrat::SetDefaultCorners(double *x1, double *x2, double *y1, double *y2)
{
   *x1 = -150;
   *x2 =  150;
   *y1 = -100;
   *y2 =  100;
}

double Quadrat::SetDefaultParams(int Index)
{
   if (Index<0) return 0.0;
   if (Index >= 2) return 0.0;
   return QuadratPar[Index];
}

void Quadrat::CalcOrbit(void)
// Berechnung fr orbitale Tpen
{
double h;

   h  = OrbY - sin(OrbX);
   OrbY = p[0] -OrbX;
   OrbX = h;
}


char* Quadrat::GetFracInfo(void)
{
   return 
"Orbit in two dimensions.\n\n\
x=y(n-1) - sin(x(n-1))\n\
y=C - x(n-1)\n\n\
One Parameter: Constant C\n";
}

int Quadrat::SetupFrac(BaseFract* Frac) // type specific-setup
{
GenericDlg GDlg = GenericDlg(Frac, 0, "Quadrat settings");

   GDlg.SetParameterNum(1);
   GDlg.SetHeader(TRS("Quadrat Parameters"));
   GDlg.SetParameterText(0, "C");
   
   if (GDlg.exec()) {
      return GDlg.SetSpecificParams();
   } else
      return FALSE;
}


