// Fraktaltyp Stern
// p[0] = pixel.x
// p[1] = pixel.y
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "mymath.h"
#include "star.h"
#define TRS klocale->translate

double StarPar[3] = {-60,-1,-42};

void Star::Init(int SizeX, int SizeY)
{
int i;

   BaseFract::Init(SizeX, SizeY);
   SetDefaultCorners(&li,&re,&un,&ob);
   for (i=0; i<16;i++) p[i]=SetDefaultParams(i);
   SetSize(SizeX, SizeY);
}

void Star::SetDefaultCorners(double *x1, double *x2, double *y1, double *y2)
{
   *x1 = -2000;
   *x2 =  2000;
   *y1 = -1500;
   *y2 =  1500;
}

double Star::SetDefaultParams(int Index)
{
   if (Index<0) return 0.0;
   if (Index >= 3) return 0.0;
   return StarPar[Index];
}

void Star::InitOrbit(void) {
   OrbX=0.1;
   OrbY=0.1;
   OrbZ=0.1;
}

void Star::CalcOrbit(void)
// Berechnung fr orbitale Tpen
{
// Orbit Typ1 Version a
double h;//,h1,h2;

   h  = OrbY - sign(OrbX) * (fabs(sin(OrbX)*cos(p[1]) + p[2] - OrbX*sin(p[0]+p[1]+p[2])));
   OrbY = p[0]-OrbX;
   OrbX = h;
}


char* Star::GetFracInfo(void)
{
   return 
"Orbit in two dimensions\n\n\
   X(n+1) = Y(n) - sign(X(n)) * (fabs(sin(X(n))*cos(b) + c - X(n)*sin(a+b+c)));\n\
   Y(n+1) = a-X(n);\n\n\
Three parameters: a,b,c";

}

int Star::SetupFrac(BaseFract* Frac) // type specific-setup
{
GenericDlg GDlg = GenericDlg(Frac, 0, "Star settings");

   GDlg.SetHeader(TRS("Parameters a,b,c"));
   GDlg.SetParameterNum(2);
   GDlg.SetParameterText(0,"a");
   GDlg.SetParameterText(1,"b");
   GDlg.SetParameterText(2,"c");

   if (GDlg.exec()) {
      return GDlg.SetSpecificParams();
   } else
      return FALSE;
}
