#ifndef STAR_H
#define STAR_H
#include <qwidget.h>
#include <qlabel.h>
#include <qpushbt.h>
#include <qdialog.h>
#include <qlined.h>
#include <qchkbox.h>
#include "basefrac.h"

class Star : public BaseFract
{
public:
   virtual void Init(int SizeX, int SizeY);
   virtual void SetDefaultCorners(double *x1, double *x2, double *y1, double *y2);
   virtual double SetDefaultParams(int);
   virtual int GetFracClass(void) { return FC_ORBIT; }; // FracKlasse
   virtual void InitOrbit(void);
   virtual void CalcOrbit(void);
   virtual int GetFracType() { return FT_STAR; }
   virtual char* GetFracName(void) { return "Stern"; }
   virtual char* GetFracInfo(void);    // Informationen ber dieses Fraktal
   virtual int SetupFrac(BaseFract* Frac); // type specific-setup
private:
};

#endif