// Fraktaltyp Wankel
// p[0] = pixel.x
// p[1] = pixel.y
#include <stdio.h>
#include <stdlib.h>
#define TRS klocale->translate
#include "wankel.h"

double WankelPar[2] = {0, 0.0};

void Wankel::Init(int SizeX, int SizeY)
{
int i;

   BaseFract::Init(SizeX, SizeY);
   SetDefaultCorners(&li,&re,&un,&ob);
   for (i=0; i<16;i++) p[i]=SetDefaultParams(i);
   SetSize(SizeX, SizeY);
}

void Wankel::SetDefaultCorners(double *x1, double *x2, double *y1, double *y2)
{
   *x1 = -2.0;     // Gre des Fraktals
   *x2 =  2.0;
   *y1 = -1.5;
   *y2 =  1.5;
}

double Wankel::SetDefaultParams(int Index)
{
   if (Index<0) return 0.0;
   if (Index >= 2) return 0.0;
   return WankelPar[Index];
}

int Wankel::CalcPoint(int x, int y)
{
double rx = li+dx*x;
double ry = un+dy*y;
double h,zr,zi,tr,ti,pr,pi;;
int    iter=0;

  zr=rx; zi=ry;
  pr = p[0];  pi=p[1];
  do {
    tr = zr; ti = zi;    // temp = z

    h= zr*zr-zi*zi-pr;   // z = z + zp
    zi = 2.0*zr*zi-pi;
    zr=h;

    pr = tr;             // zp = temp
    pi = ti;
    iter++;
   } while ((iter<MaxIter) && ConvTest(zr*zr,zi*zi) );

   return PostCompute(iter,zr,zi);
}

char* Wankel::GetFracInfo(void)
{
   return 
"Formula: z=Pixel;  p=(p0,p1);\n\
loop {\n\
   temp=z\n\
   z=z^2+p\n\
   p=temp\n\
until (|z|>bail)\n\n\
parameters: initial p";
}

int Wankel::SetupFrac(BaseFract* Frac) // type specific-setup
{
/*WankelDlg MDlg = WankelDlg(Frac, 0, "Wankel settings");

   if (MDlg.exec()) {
      return MDlg.SetSpecificParams();
   } else
      return FALSE;
*/
GenericDlg MDlg = GenericDlg(Frac, 0, "Wankel settings");

   MDlg.SetHeader(TRS("Image Constant Values"));
   MDlg.SetParameterNum(1);
   MDlg.SetParameterText(0, TRS("P1"));
   MDlg.SetParameterText(1, "P2");
   if (MDlg.exec()) {
      return MDlg.SetSpecificParams();
   } else
      return FALSE;
}


// -----------------------------------------
/*
WankelDlg::WankelDlg(BaseFract* Frac, QWidget* parent=0, const char* name=0):
          QDialog(parent,name, WStyle_DialogBorder)
{
char Strg[32];
   Fractal = Frac;
   setFixedSize(300,200);
   setCaption(Fractal->GetFracName());

   QLabel *Label0 = new QLabel("Offset values of x(0)", this, "Label0");
   Label0->setGeometry(30,20,150,20);

   ConstX = new QLineEdit(this, "OffsetX");
   ConstX->setGeometry(100,50,125,22);
   sprintf(Strg,"%0.14f", Fractal->p[0]);
   ConstX->setText(Strg);
   ConstY = new QLineEdit(this, "OffsetY");
   ConstY->setGeometry(100,80,125,22);
   sprintf(Strg,"%0.14f", Fractal->p[1]);
   ConstY->setText(Strg);

   QLabel* Label1 = new QLabel("OffsetX",this,"Label1");
   Label1->setGeometry(20,50,75,20);
   QLabel* Label2 = new QLabel("OffsetY",this,"Label2");
   Label2->setGeometry(20,80,75,20);

   RegularCheck = new QCheckBox("Regular Fractal", this, "RegularCheck");
   RegularCheck->setGeometry(20,110,150,20);
   RegularCheck->setChecked(Fractal->l[0]!=0);

   QPushButton* OkBtn = new QPushButton("OK", this, "OkBtn");
   OkBtn->setGeometry(20,150,80,30);
   OkBtn->setDefault(TRUE);
   connect(OkBtn,SIGNAL(clicked()), this, SLOT(accept()) );

   QPushButton* DefaultsBtn = new QPushButton("Defaults", this, "DefautsBtn");
   DefaultsBtn->setGeometry(110,150,80,30);
   connect(DefaultsBtn,SIGNAL(clicked()), this, SLOT(SetDefaults()) );

   QPushButton* CancelBtn = new QPushButton("Cancel", this, "OkBtn");
   CancelBtn->setGeometry(200,150,80,30);
   connect(CancelBtn,SIGNAL(clicked()), this, SLOT(reject()) );
}

int WankelDlg::SetSpecificParams(void)
{
char* eptr;
double p0,p1;
long l0;

printf("vor p0\n");
   p0 = strtod(ConstX->text(), &eptr);
   if (*eptr!=0) return FALSE;

printf("nach p0\n");
   p1 = strtod(ConstY->text(), &eptr);
   if (*eptr!=0) return FALSE;

   l0 = 0;
   if (RegularCheck->isChecked()) 
      l0 = 1; 

printf("hier\n");
   Fractal->p[0] = p0;
   Fractal->p[1] = p1;
   Fractal->l[0] = l0;
   return TRUE;
}

void WankelDlg::SetDefaults()
{
char Strg[32];

   sprintf(Strg,"%0.14f", Fractal->SetDefaultParams(0));
   ConstX->setText(Strg);
   sprintf(Strg,"%0.14f", Fractal->SetDefaultParams(1));
   ConstY->setText(Strg);
   RegularCheck->setChecked(FALSE);
}*/